require("AnAl")
local actor = require("luactor")
require("actor")
require("world")
require('camera')
local vector = require('vector')
local spine = require("spine-love.spine")
local json = require(("dkjson"))
local World
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self) end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "World",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  World = _class_0
end
local __world = World()
player = { }
windowWidth = 640
windowHeight = 384
local screen_pan_time = 1
local __add_to_score_time = 0
local __food_pickup_time = 0
local __food_take_away_time = 0
local __gold_pickup_time = 0
local __drops = nil
local __tick = 0
local __last_time = 0
local __replay = { }
local __random_gen = nil
local __cosmetic_random_gen = love.math.newRandomGenerator(1)
local __world_accumulator = 0
local __screenWidth = 0
local __screenHeight = 0
local PHYSICS_STEP = 1 / 40
local __random
__random = function()
  return __random_gen:random()
end
local __cosmetic_random
__cosmetic_random = function()
  return __cosmetic_random_gen:random()
end
local HUD_SECONDARY_X = 180
local HUD_HP_X = 0
local HUD_TIME_X = windowWidth - 95
local HUD_SCORE_X = 400
local HUD_SCORE_Y = 20
local HUD_GOLD_X = windowWidth / 2 - 40
local HP_PER_BALL = 25
local MAX_HP = 300
local REGULAR_CATEGORY = 1
local SWORD_CATEGORY = 2
local DMG_CATEGORY = 3
local GHOST_DMG_CATEGORY = 4
local ROLLING_CATEGORY = 5
local __dried_goods = {
  'Bustersword',
  'Doublejumppotion',
  'Greatsword',
  'HPupbox',
  'Kunaibox',
  'Shortsword',
  'Tntbox',
  'Zpipebox'
}
local latest_poly = nil
local latest_line = nil
local latest_point = nil
local __white_screen_time = 0
local __black_bands_time = 0
local __black_bands = false
local __world_pause = 0
local __screen_shake = 0
local __show_center_rect = false
local skeletonRenderer = spine.SkeletonRenderer.new()
local game_over_font_h = 50
levels = { }
local __assert
__assert = function(val)
  if not val then
    print("ERROR: variable not set")
    print(debug.traceback())
    return os.exit()
  end
end
local __assert_with_msg
__assert_with_msg = function(val, msg)
  if not val then
    print("ERROR: variable not set: " .. msg)
    print(debug.traceback())
    return os.exit()
  end
end
local startswith
startswith = function(s, prefix)
  return string.sub(s, 1, string.len(prefix)) == prefix
end
local sign
sign = function(x)
  if x < 0 then
    return -1
  else
    return 1
  end
end
local distance
distance = function(x1, y1, x2, y2)
  return math.sqrt((x1 - x2) ^ 2 + (y1 - y2) ^ 2)
end
local easeOutQuad
easeOutQuad = function(t, b, c, d)
  t = t / d
  return -c * t * (t - 2) + b
end
local __get_class_from_string
__get_class_from_string = function(str)
  if str == nil then
    return nil
  end
  local name = string.upper(string.sub(str, 1, 1)) .. string.sub(str, 2)
  return _G[name]
end
local __set_spine_scale
__set_spine_scale = function(skeleton, scale)
  for i, bone in ipairs(skeleton.bones) do
    bone.scaleX = scale
    bone.scaleY = scale
  end
end
local __draw_text
__draw_text = function(txt, x, y, z, scale)
  local r, g, b, a = love.graphics.getColor()
  love.graphics.setColor(0, 0, 0, a)
  love.graphics.print(txt, x + 2, y + 2, z, scale)
  love.graphics.setColor(r, g, b, a)
  return love.graphics.print(txt, x, y, z, scale)
end
local __loadSkeleton
__loadSkeleton = function(o, object_id, path, jsonFile, animation, skin, scale, x, y)
  __assert_with_msg(path, 'skeleton path')
  __assert_with_msg(jsonFile, 'skeleton json')
  __assert_with_msg(animation, 'skeleton animation')
  local loader
  loader = function(fname)
    return love.graphics.newImage(path .. "/" .. fname)
  end
  local fname = path .. "/" .. jsonFile .. ".atlas"
  local atlas = spine.TextureAtlas.new(spine.utils.readFile(fname), loader)
  __assert_with_msg(atlas, 'skeleton atlas')
  json = spine.SkeletonJson.new(spine.AtlasAttachmentLoader.new(atlas))
  json.scale = scale
  local skeletonData = json:readSkeletonDataFile(path .. "/" .. jsonFile .. ".json")
  local skeleton = spine.Skeleton.new(skeletonData)
  skeleton.x = x
  skeleton.y = y
  skeleton.flipX = false
  skeleton.flipY = true
  if skin then
    skeleton:setSkin(skin)
  end
  skeleton:setToSetupPose()
  local stateData = spine.AnimationStateData.new(skeletonData)
  local state = spine.AnimationState.new(stateData)
  state.onComplete = function(trackIndex, loopCount)
    return o:send(object_id, 'end_of_anim', {
      anim_name = state:getCurrent(trackIndex).animation.name
    })
  end
  state.onEvent = function(trackIndex, event)
    return o:send(object_id, 'anim_event', {
      anim_name = state:getCurrent(trackIndex).animation.name,
      event_name = event.data.name
    })
  end
  state:apply(skeleton)
  return skeleton, state
end
local __images = { }
local __load_image
__load_image = function(file_name)
  if __images[file_name] then
    return __images[file_name]
  end
  local image = love.graphics.newImage(file_name)
  __images[file_name] = image
  return image
end
local __sounds = { }
local __play_sound
__play_sound = function(file_name)
  local source = __sounds[file_name]
  if source == nil then
    if not love.filesystem.exists(file_name) then
      return 
    end
    local wav = love.sound.newSoundData(file_name)
    source = love.audio.newSource(wav)
    __sounds[file_name] = source
  else
    love.audio.rewind(source)
  end
  return love.audio.play(source)
end
local __get_time
__get_time = function()
  return __tick
end
local __load_anim
__load_anim = function(path, x, y, speed, a, b)
  local img = __load_image(path)
  return newAnimation(img, x, y, speed, a, b)
end
local __position_is_clear
__position_is_clear = function(room, start_pos, end_pos)
  local clear = true
  local handle_contact
  handle_contact = function(fixture, x, y, xn, yn, fraction)
    clear = false
    return 0
  end
  room.world:rayCast(start_pos[1], start_pos[2], end_pos[1], end_pos[2], handle_contact)
  return clear
end
local __find_closest_point
__find_closest_point = function(room, start_pos, target_pos)
  local hit_x = nil
  local hit_y = nil
  local dist = 99999
  local handle_contact
  handle_contact = function(fixture, x, y, xn, yn, fraction)
    local new_dist = distance(start_pos[1], start_pos[2], x, y)
    if new_dist < dist then
      dist = new_dist
      hit_x = x
      hit_y = y
    end
    return 1
  end
  room.world:rayCast(start_pos[1], start_pos[2], target_pos[1], target_pos[2], handle_contact)
  return hit_x, hit_y
end
local __throw_object
__throw_object = function(klass, thrower, direction, vel)
  __assert_with_msg(thrower.room, 'thrower')
  if direction == nil then
    direction = thrower.facing_direction
  end
  local target_pos = {
    thrower.x + direction * 40,
    thrower.y
  }
  local hit_x, hit_y = __find_closest_point(thrower.room, {
    thrower.x,
    thrower.y
  }, target_pos)
  if hit_x then
    target_pos[1] = hit_x
    target_pos[2] = hit_y
  end
  local o = klass()
  thrower:send(o.id, 'set_pos', target_pos)
  if vel == nil then
    vel = {
      thrower.facing_direction * 200 + thrower.x_vel,
      -1000
    }
  end
  return thrower:send(o.id, 'set_vel', vel)
end
local current_room = { }
local warp_to_level
warp_to_level = function(obj, level)
  obj.last_level_warp_time = 1 + __get_time()
  current_room = levels[level].rooms["start"]
  return __world:send(obj.id, 'set_room', levels[level].rooms["start"])
end
local __message = nil
local __message_remove_time = 0
local __message_duration = 3
local __message_size = 1.5
local newbbox_quad
newbbox_quad = function(o)
  local bbox_type = 'dynamic'
  if o.bbox_type then
    bbox_type = o.bbox_type
  end
  o.body = love.physics.newBody(o.room.world, o.x, o.y, bbox_type)
  o.shape = love.physics.newRectangleShape(0, 0, o.bboxed_quad_w, o.bboxed_quad_h)
  o.fixture = love.physics.newFixture(o.body, o.shape, 1)
  o.fixture:setCategory(DMG_CATEGORY)
  o.fixture:setUserData(o)
  o.fixture:setFriction(o.friction)
  o.body:setMass(o.mass)
  return o.body:setLinearDamping(1)
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right_released = function(self, msg, sender)
      self.right_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_right_released'
      })
    end,
    cmd_left_released = function(self, msg, sender)
      self.left_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_left_released'
      })
    end,
    cmd_up_released = function(self, msg, sender)
      self.up_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_up_released'
      })
    end,
    cmd_down_released = function(self, msg, sender)
      self.down_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_down_released'
      })
    end,
    cmd_primary_released = function(self, msg, sender)
      self.primary_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_primary_released'
      })
    end,
    cmd_secondary_released = function(self, msg, sender)
      self.secondary_down = false
      return table.insert(self.commands, {
        __get_time(),
        'cmd_secondary_released'
      })
    end,
    cmd_right_pressed = function(self, msg, sender)
      self.right_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_right_pressed'
      })
    end,
    cmd_left_pressed = function(self, msg, sender)
      self.left_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_left_pressed'
      })
    end,
    cmd_up_pressed = function(self, msg, sender)
      self.up_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_up_pressed'
      })
    end,
    cmd_down_pressed = function(self, msg, sender)
      self.down_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_down_pressed'
      })
    end,
    cmd_primary_pressed = function(self, msg, sender)
      self.primary_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_primary_pressed'
      })
    end,
    cmd_secondary_pressed = function(self, msg, sender)
      self.secondary_down = true
      return table.insert(self.commands, {
        __get_time(),
        'cmd_secondary_pressed'
      })
    end,
    step = function(self, msg, sender)
      if self.right_down then
        self:send(player.id, 'cmd_right')
      end
      if self.left_down then
        self:send(player.id, 'cmd_left')
      end
      if self.up_down then
        self:send(player.id, 'cmd_up')
      end
      if self.down_down then
        self:send(player.id, 'cmd_down')
      end
      if self.primary_down then
        self:send(player.id, 'cmd_primary')
      end
      if self.secondary_down then
        return self:send(player.id, 'cmd_secondary')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.commands = { }
      self.right_down = false
      self.left_down = false
      self.up_down = false
      self.down_down = false
      self.down_down = false
      self.primary_down = false
      self.secondary_down = false
    end,
    __base = _base_0,
    __name = "InputRecorder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  InputRecorder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init_full = function(self, msg, sender)
      local target_pos = {
        self.x,
        1000
      }
      local hit_x, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, target_pos)
      if hit_y then
        return self:send(self.id, 'set_pos', {
          self.x,
          hit_y - self.h / 2
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PlacedOntoFloor",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PlacedOntoFloor = _class_0
end
local __monsters = { }
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      return table.insert(__monsters, self)
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(__monsters) do
        if obj == self then
          table.remove(__monsters, key)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Baddie",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Pickupper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Baddie = _class_0
end
local __awards_combo = { }
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      return table.insert(__awards_combo, self)
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(__awards_combo) do
        if obj == self then
          table.remove(__awards_combo, key)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Awardscombo",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Awardscombo = _class_0
end
local __steppers = { }
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      for key, obj in pairs(__steppers) do
        if obj == self then
          table.remove(__steppers, key)
        end
      end
    end,
    set_vel = function(self, msg, sender)
      self.x_vel = msg[1]
      self.y_vel = msg[2]
    end,
    step = function(self, dt, sender)
      self.x = self.x + (self.x_vel * dt)
      self.y = self.y + (self.y_vel * dt)
    end,
    init_full = function(self, msg, sender)
      if self.world_obj and self.world_obj.properties.mixins then
        return self:send(self.id, 'mixin', self.world_obj.properties.mixins)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x_vel = 0
      self.y_vel = 0
      return table.insert(__steppers, self)
    end,
    __base = _base_0,
    __name = "Stepper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Stepper = _class_0
end
local __damageables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      for key, obj in pairs(__damageables) do
        if obj == self then
          table.remove(__damageables, key)
        end
      end
    end,
    step = function(self, msg, sender)
      local atk = table.remove(self.queued_attacks)
      if not atk then
        self.queued_attacks = { }
        return 
      end
      return self:send(self.id, 'dmg', atk)
    end,
    execute_attack = function(self, msg, sender)
      return table.insert(self.queued_attacks, msg)
    end,
    dmg = function(self, msg, sender)
      self:send(self.id, 'mixin', 'FlashesWhite')
      self:send(sender, "dmging", msg)
      self:send(self.id, "pre_dmg", msg)
      self.hp = self.hp - msg.pts
      if self.hp <= 0 then
        if 200 < msg.pts then
          local b = Text()
          b.scale = 0.8
          b.var_short_lived_life_time = 0.7
          self:send(b.id, 'set_pos', {
            self.x,
            self.y - 80
          })
          self:send(b.id, 'set_vel', {
            __cosmetic_random() * 50,
            -50 - __cosmetic_random() * 10
          })
          self:send(b.id, 'set_text', "CRITICAL!")
        end
        self:send(self.id, 'die', "you're dead")
        return self:send(sender, 'killed_something', {
          other = self
        })
      end
    end,
    die = function(self, msg, sender)
      return self:send(self.id, "remove")
    end,
    hp = function(self, msg, sender)
      self.hp = self.hp + msg.pts
      self.hp = math.min(self.hp, math.min(self.hp_max, MAX_HP))
      local b = Text()
      self:send(b.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(b.id, 'set_vel', {
        0,
        -50 - __cosmetic_random() * 10
      })
      self:send(b.id, 'set_text', "+" .. msg.pts)
      return self:send(b.id, 'mixin', 'Green')
    end,
    increase_max_hp = function(self, msg, sender)
      self.hp_max = self.hp_max + msg.pts
      self.hp_max = math.min(self.hp_max, MAX_HP)
    end,
    attack_collide = function(self, msg, sender)
      if msg.category_a == SWORD_CATEGORY and msg.category_b == SWORD_CATEGORY then
        self:send(self.id, 'sword_contact', msg.collision_params)
        self:send(msg.b.id, 'sword_contact', msg.collision_params)
        return 
      end
      if msg.a.id ~= msg.b.id and (msg.category_b == DMG_CATEGORY or msg.category_b == GHOST_DMG_CATEGORY) then
        if not self.objects_hit[msg.b] then
          self.objects_hit[msg.b] = 1
          if msg.b.faction ~= nil and msg.b.faction ~= self.faction then
            self:send(self.id, 'attack_collide_confirm', msg)
          end
          return self:send(msg.b.id, 'dmg', {
            pts = self.dmg_pts * (msg.dmg_bonus or 1),
            atk_pos = msg.collision_params.pos,
            atk_origin = {
              self.x,
              self.y
            },
            attacker_id = self.id
          })
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.hp = 50
      self.hp_max = 100
      self.queued_attacks = { }
      return table.insert(__damageables, self)
    end,
    __base = _base_0,
    __name = "Damageable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Damageable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    touch = function(self, other_id, sender)
      return self:send(other_id, 'dmg', {
        pts = self.dmg_pts
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PainfulTouch",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Touchable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PainfulTouch = _class_0
end
local random_direction_cosmetic
random_direction_cosmetic = function(magnitude)
  return {
    magnitude - __cosmetic_random() * magnitude * 2,
    -math.sin(__cosmetic_random()) * magnitude
  }
end
local random_direction
random_direction = function(magnitude)
  return {
    magnitude - __random() * magnitude * 2,
    -__random() * magnitude
  }
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      __play_sound("assets/sound/explosion.wav")
      local magnitude = 300
      for i = 1, 10 do
        local o = ExplosionDebris()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SmokeWhenDead",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SmokeWhenDead = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      local o = Smoke()
      return self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PuffsWhenDead",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PuffsWhenDead = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      local magnitude = 100
      local o = Heart()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      for i = 1, 4 do
        o = Giblet()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y - 60
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Gibable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Gibable = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1
      self:add_handler("init", Block.init)
      self:_mixin(BBoxed)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(QuadSprite)
      self.bbox_radius = 1
    end,
    init = function(self, msg, sender)
      self.mass = 1
      self.restitution = 0.5
      self.sprite = self.room.map.tilesets[1].image
      self.quad = love.graphics.newQuad(2 * 32, 2 * 32, 16, 16, self.sprite:getWidth(), self.sprite:getHeight())
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Block",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Block = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(ShortLived)
      self.var_short_lived_life_time = 2
      self:add_handler("init", Text.init)
      self:add_handler("draw", Text.draw)
      self:add_handler("set_text", Text.set_text)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:_mixin(Drawable)
    end,
    draw = function(self, msg, sender)
      love.graphics.push()
      love.graphics.translate(self.x, self.y)
      love.graphics.scale(self.scale * 0.5, self.scale * 0.5)
      __draw_text(self.text, 0, 0, 0, 1)
      return love.graphics.pop()
    end,
    set_text = function(self, text, sender)
      self.text = text
    end,
    init = function(self, msg, sender)
      self.text = "x"
      self.mass = 1
      self.restitution = 0.5
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Text",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Text = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      __play_sound("assets/sound/break.wav")
      local magnitude = 10
      local klass = Block
      if self.dissolve_class then
        klass = _G[self.dissolve_class]
      end
      for i = 1, self.dissolve_count or 6 do
        local o = klass()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Dissolves",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Dissolves = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    drop_items = function(self, msg, sender)
      __assert_with_msg(self.dropped_object_classes, 'dropped item')
      local magnitude = 10
      for key, klass in pairs(self.dropped_object_classes) do
        if __random() <= self.droprate then
          local o = klass()
          self:send(o.id, 'set_pos', {
            self.x,
            self.y
          })
          self:send(o.id, 'set_vel', random_direction(magnitude))
          self:send(self.id, 'dropped_item', {
            id = o.id
          })
        end
      end
    end,
    drop_item = function(self, msg, sender)
      __assert_with_msg(self.dropped_object_classes, 'dropped item')
      if __random() <= self.droprate then
        local magnitude = 10
        local klass = self.dropped_object_classes[math.floor(__random() * 10) % #self.dropped_object_classes + 1]
        local o = klass()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y - 30
        })
        self:send(o.id, 'set_vel', random_direction(magnitude))
        return self:send(self.id, 'dropped_item', {
          id = o.id
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.droprate = 1
    end,
    __base = _base_0,
    __name = "DropsItems",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DropsItems = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      if not self.died then
        return self:send(self.id, 'drop_items')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DropsItemsOnDeath",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'DropsItems'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DropsItemsOnDeath = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      if not self.died then
        return self:send(self.id, 'drop_item')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DropsItemOnDeath",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'DropsItems'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DropsItemOnDeath = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      self:send(self.id, 'drop_item')
      for i = 1, 10 do
        local o = ExplosionDebris()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(o.id, 'set_vel', random_direction(magnitude))
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DropsItemOnRemoval",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'DropsItems'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DropsItemOnRemoval = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      local magnitude = 300
      for i = 1, 4 do
        local o = BugGiblet()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GibableBug",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GibableBug = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      local magnitude = 300
      local o = Skull()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      o = Heart()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      for i = 1, 4 do
        o = Giblet()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y - 60
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
      if math.abs(__cosmetic_random()) < 0.4 then
        o = Ribcage()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y - 60
        })
        self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
      end
      for i = 1, 4 do
        if math.abs(__cosmetic_random()) < 0.5 then
          o = Limb()
          self:send(o.id, 'set_pos', {
            self.x,
            self.y - 60
          })
          self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GibableWithBones",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GibableWithBones = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      if msg.other_faction == self.faction then
        return 
      end
      if self.last_damage_on_contact <= __get_time() then
        self.last_damage_on_contact = self.var_damage_on_contact_time + __get_time()
        return self:send(msg.other_id, 'dmg', {
          pts = self.dmg_pts
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_damage_on_contact_time = 0
      self.last_damage_on_contact = 0
    end,
    __base = _base_0,
    __name = "DamageOnContact",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Contactable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DamageOnContact = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self:send(self.id, "mixout", "Attacker")
      self:send(self.id, "mixout", "AttackWhenCloseToTarget")
      self:send(self.id, "mixout", "Controlled")
      self:send(self.id, "mixout", "Hovers")
      self:send(self.id, "mixout", "PlayerFollower")
      self:send(self.id, "mixout", "RandomJumper")
      self:send(self.id, "mixout", "RandomSprinter")
      return self:send(self.id, "mixout", "Screamer")
    end,
    was_mixed_out = function(self, msg, sender)
      return table.insert(self.sleeping_mixed_out, msg)
    end,
    dmg = function(self, msg, sender)
      if self.sleeping then
        self:send(self.id, 'mixout', 'Sleeping')
        for key, component_name in pairs(self.sleeping_mixed_out) do
          self:send(self.id, "mixin", component_name)
        end
      end
    end,
    step = function(self, dt, sender)
      self.sleeping = true
      self.ps_sleep:update(dt)
      self.ps_sleep:setPosition(self.x, (self.head_y or self.y) - 40)
      if math.abs(math.sin(__get_time() * 20)) < 0.1 then
        return self.ps_sleep:emit(1)
      end
    end,
    draw = function(self, msg, sender)
      return love.graphics.draw(self.ps_sleep)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sleeping = false
      self.sleeping_mixed_out = { }
      local img = __load_image("assets/gfx/z.png")
      self.ps_sleep = love.graphics.newParticleSystem(img, 20)
      self.ps_sleep:setParticleLifetime(1, 2)
      self.ps_sleep:setSizes(1.2)
      self.ps_sleep:setLinearAcceleration(-20, -30, -20, -30)
      return self.ps_sleep:setColors(255, 255, 255, 255, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "Sleeping",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Sleeping = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      if msg.activator_id == player.id then
        return 
      end
      return self:send(msg.activator_id, "mixin", "Sleeping")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SleepOnContact",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SleepOnContact = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      self:send(self.id, 'die')
      return self:send(self.id, 'remove')
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DiesOnContact",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DiesOnContact = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      if self.faction ~= msg.other_faction then
        if 0.5 < math.abs(msg.normal[1]) and math.abs(msg.normal[2]) < 0.5 then
          if self.last_damange_on_contact_so <= __get_time() then
            self.last_damange_on_contact_so = self.var_damange_on_contact_so_time + __get_time()
            return self:send(msg.other_id, 'dmg', {
              pts = self.dmg_pts
            })
          end
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_damange_on_contact_so_time = 0
      self.last_damange_on_contact_so = 0
    end,
    __base = _base_0,
    __name = "DamageOnContactSideOnly",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Contactable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DamageOnContactSideOnly = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      if not self.stomped and 0.7 < msg.normal[2] and self.faction ~= msg.other_faction then
        self.stomped = true
        return self:send(self.id, 'dmg', {
          pts = 30
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.stomped = false
    end,
    __base = _base_0,
    __name = "Stompable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Contactable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Stompable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmging = function(self, msg, sender)
      return self:send(self.id, "remove")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "RemovedOnDamage",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RemovedOnDamage = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if math.abs(self.x_vel) < 200 and math.abs(self.y_vel) < 200 then
        self:send(self.id, "mixout", "Touchable")
        self.no_dmg_in = false
      else
        if not self.no_dmg_in then
          self:send(self.id, "mixin", "Touchable")
          self.no_dmg_in = true
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.no_dmg_in = true
    end,
    __base = _base_0,
    __name = "NoDamageIfStill",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  NoDamageIfStill = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.last_level_warp_time < __get_time() then
        if love.keyboard.isDown("1") then
          return warp_to_level(self, 1)
        elseif love.keyboard.isDown("2") then
          return warp_to_level(self, 2)
        elseif love.keyboard.isDown("3") then
          return warp_to_level(self, 3)
        elseif love.keyboard.isDown("4") then
          return warp_to_level(self, 4)
        elseif love.keyboard.isDown("5") then
          return warp_to_level(self, 5)
        elseif love.keyboard.isDown("6") then
          return warp_to_level(self, 6)
        elseif love.keyboard.isDown("7") then
          return warp_to_level(self, 7)
        elseif love.keyboard.isDown("8") then
          return warp_to_level(self, 8)
        elseif love.keyboard.isDown("9") then
          return warp_to_level(self, 9)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_level_warp_time = 0
    end,
    __base = _base_0,
    __name = "Levelwarper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Levelwarper = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    set_pos = function(self, msg, sender)
      self.x = msg[1]
      self.y = msg[2]
    end,
    set_room = function(self, msg, sender)
      self.room = msg
    end,
    enter_room = function(self, msg, sender)
      __black_bands = false
      if self.last_room_change_time < __get_time() then
        self.last_room_change_time = 1 + __get_time()
        local tdoor = msg.door.world_obj.target_door
        current_room = tdoor.room
        self:send(self.id, 'set_pos', {
          tdoor.x,
          tdoor.y
        })
        self:send(self.id, 'set_room', tdoor.room)
        if tdoor.type == "lockeddoor" then
          self:send(tdoor.object.id, 'mixin', 'Doorable')
          return self:send(tdoor.object.id, 'mixout', 'OpensByKey')
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x = 0
      self.y = 100
      self.room = current_room
      self.last_room_change_time = 0
    end,
    __base = _base_0,
    __name = "RoomOccupier",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RoomOccupier = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      if __cosmetic_random() < 0.5 then
        __play_sound("assets/sound/hurt2.wav")
      else
        __play_sound("assets/sound/hurt.wav")
      end
      local b = self:blood_class()
      if msg.atk_pos then
        return self:send(b.id, 'set_pos', msg.atk_pos)
      else
        return self:send(b.id, 'set_pos', {
          self.x,
          self.y
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, msg, sender)
      if not self.blood_class then
        self.blood_class = Blood
      end
    end,
    __base = _base_0,
    __name = "Bleeds",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bleeds = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      local b = Text()
      self:send(b.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(b.id, 'set_vel', {
        0,
        -50 - __cosmetic_random() * 50
      })
      self:send(b.id, 'set_text', "-" .. msg.pts)
      return self:send(b.id, 'mixin', "Red")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShowsDmg",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShowsDmg = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender) end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Walker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = { }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Walker = _class_0
end
do
  local _parent_0 = Walker
  local _base_0 = {
    step = function(self, dt, sender)
      if not self.touching_ground then
        return self:send(self.id, 'enqueue_anim', {
          anim_name = 'jumping'
        })
      else
        return _parent_0.step(self, dt, sender)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "WalkerJumper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = { }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  WalkerJumper = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.its_roll_time = false
    end,
    roll = function(self, msg, sender)
      if self.rolling then
        return 
      end
      self.rolling = true
      self:send(self.id, 'set_anim', {
        anim_name = 'roll'
      })
      self.fixture:setMask(DMG_CATEGORY, GHOST_DMG_CATEGORY)
      self.fixture:setCategory(ROLLING_CATEGORY)
      self.food = self.food - 1
      __play_sound("assets/sound/roll.wav")
      __food_take_away_time = __get_time() + 0.3
    end,
    jump = function(self, msg, sender)
      if self.rolling then
        self.rolling = false
        self:send(self.id, 'set_anim', {
          anim_name = 'roll_dive',
          force = true
        })
        return self:send(self.id, 'end_roll')
      end
    end,
    end_roll = function(self, msg, sender)
      self.rolling = false
      self.its_roll_time = false
      if self.fixture then
        self.fixture:setMask()
        return self.fixture:setCategory(DMG_CATEGORY)
      end
    end,
    end_of_anim = function(self, msg, sender)
      if self.rolling then
        return self:send(self.id, 'end_roll')
      end
    end,
    anim_event = function(self, msg, sender)
      if msg.event_name == 'roll_event_start' then
        self.its_roll_time = true
      elseif msg.event_name == 'roll_event_end' then
        self.its_roll_time = false
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Roller",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Roller = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_down_pressed = function(self, dt, sender)
      if 80 < math.abs(self.x_vel) and self.touching_ground and (self.right_down or self.left_down) then
        self:send(self.id, 'roll')
        return 
      end
      self.crouching = true
      self.idle_anim = 'crouch_idle'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    cmd_down_released = function(self, dt, sender)
      if self.crouching then
        self.crouching = false
        return self:send(self.id, 'uncrouch')
      end
    end,
    set_room = function(self, room, sender)
      self.crouching = false
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.crouching = false
    end,
    __base = _base_0,
    __name = "Croucher",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = { }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Croucher = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.yvel = self.yvel + (100 * dt)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Falls",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Falls = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    click = function(self, msg, sender)
      self:send(self.id, 'set_pos', msg)
      return self:send(self.id, 'set_vel', {
        0,
        0
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "MouseTeleporter",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MouseTeleporter = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      local x, y = love.mouse.getPosition()
      x = x + camera._x
      y = y + camera._y
      if self.x < x then
        return self:send(self.id, 'cmd_right')
      elseif self.x > x then
        return self:send(self.id, 'cmd_left')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "MouseFollower",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MouseFollower = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.target = player
      if 20 < math.abs(self.x - player.x) then
        if self.x < player.x then
          return self:send(self.id, 'cmd_right')
        elseif self.x > player.x then
          return self:send(self.id, 'cmd_left')
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PlayerFollower",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PlayerFollower = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if 0 < self.x_vel then
        self.facing_direction = 1
      end
      if self.x_vel < 0 then
        self.facing_direction = -1
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.facing_direction = 1
    end,
    __base = _base_0,
    __name = "FacesDirectionByVelocity",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FacesDirectionByVelocity = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.its_hit_time then
        return 
      end
      self.facing_direction = 1
    end,
    cmd_left = function(self, msg, sender)
      if self.its_hit_time then
        return 
      end
      self.facing_direction = -1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.facing_direction = 1
    end,
    __base = _base_0,
    __name = "FacesDirection",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FacesDirection = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      return love.graphics.setColor(255, 0, 0)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Burning",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Burning = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      return love.graphics.setColor(0, 255, 0)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Green",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Green = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      return love.graphics.setColor(255, 0, 0)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Red",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Red = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 0)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Yellow",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Yellow = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, msg, sender)
      if self.next_think < __get_time() then
        self.next_think = __get_time() + 1
        return self:send(self.id, "think", { })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, msg, sender)
      self.next_think = 0
    end,
    __base = _base_0,
    __name = "OneSecThinks",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  OneSecThinks = _class_0
end
do
  local _parent_0 = Green
  local _base_0 = {
    draw_start = function(self, msg, sender)
      _parent_0.draw_start(self, msg, sender)
      if math.abs(math.sin(__get_time() * 20)) < 0.1 then
        local f = Poisonbubble()
        self:send(f.id, 'set_pos', {
          self.x,
          self.y - 20
        })
        return self:send(f.id, "set_vel", {
          0,
          -60 * math.abs(__cosmetic_random())
        })
      end
    end,
    die = function(self, msg, sender)
      return self:send(Poisonflask().id, 'set_pos', {
        self.x,
        self.y
      })
    end,
    think = function(self, msg, sender)
      return self:send(self.id, 'dmg', {
        pts = 1
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Poisoned",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'OneSecThinks'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Poisoned = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      local v = math.abs(math.sin(__get_time() * 20)) * 500
      love.graphics.setColor(v, v, v)
      if self.flash_start_time + 0.3 < __get_time() then
        return self:send(self.id, "mixout", "Flashes")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.flash_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "Flashes",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Flashes = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      local v = 10000
      love.graphics.setColor(v, v, v)
      if self.white_flash_start_time + 0.1 < __get_time() then
        return self:send(self.id, "mixout", "FlashesWhite")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.white_flash_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "FlashesWhite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FlashesWhite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      local v = math.abs(math.sin(__get_time() * 20)) * 500
      love.graphics.setColor(v, v, 0)
      if self.flash_start_time + 0.3 < __get_time() then
        return self:send(self.id, "mixout", "FlashesYellow")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.flash_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "FlashesYellow",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FlashesYellow = _class_0
end
local drawables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_out = function(self, msg, sender)
      for key, obj in pairs(drawables) do
        if obj == self then
          table.remove(drawables, key)
        end
      end
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(drawables) do
        if obj == self then
          table.remove(drawables, key)
        end
      end
    end,
    draw = function(self, msg, sender)
      if __show_center_rect then
        return love.graphics.rectangle("fill", self.x - 2, self.y - 2, 4, 4)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
      return table.insert(drawables, self)
    end,
    __base = _base_0,
    __name = "Drawable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Drawable = _class_0
end
local __background_drawables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_out = function(self, msg, sender)
      for key, obj in pairs(__background_drawables) do
        if obj == self then
          table.remove(__background_drawables, key)
        end
      end
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(__background_drawables) do
        if obj == self then
          table.remove(__background_drawables, key)
        end
      end
    end,
    draw = function(self, msg, sender)
      if __show_center_rect then
        return love.graphics.rectangle("fill", self.x - 2, self.y - 2, 4, 4)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
      return table.insert(__background_drawables, self)
    end,
    __base = _base_0,
    __name = "BackgroundDrawable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BackgroundDrawable = _class_0
end
local __foreground_drawables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_out = function(self, msg, sender)
      for key, obj in pairs(__foreground_drawables) do
        if obj == self then
          table.remove(__foreground_drawables, key)
        end
      end
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(__foreground_drawables) do
        if obj == self then
          table.remove(__foreground_drawables, key)
        end
      end
    end,
    draw = function(self, msg, sender)
      if __show_center_rect then
        return love.graphics.rectangle("fill", self.x - 2, self.y - 2, 4, 4)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
      return table.insert(__foreground_drawables, self)
    end,
    __base = _base_0,
    __name = "ForegroundDrawable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ForegroundDrawable = _class_0
end
local __lighting_drawables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      for key, obj in pairs(__lighting_drawables) do
        if obj == self then
          table.remove(__lighting_drawables, key)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      table.insert(__lighting_drawables, self)
      return self:send(self.id, "mixout", "Drawable")
    end,
    __base = _base_0,
    __name = "LightingDrawable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  LightingDrawable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if not self.body then
        return 
      end
      __assert_with_msg(self.body, 'body')
      return love.graphics.draw(self.sprite, self.x, self.y, self.angle, self.scale, self.scale, self.sprite:getWidth() / 2, self.sprite:getHeight() / 2)
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "AngledSprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AngledSprite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if self.world_obj then
        return love.graphics.draw(self.sprite, self.x - self.sprite:getWidth() / 2, self.y + self.world_obj.height - self.sprite:getHeight(), 0, self.scale, self.scale)
      else
        return love.graphics.draw(self.sprite, self.x, self.y, 0, self.scale, self.scale, self.sprite:getWidth() / 2, self.sprite:getHeight() / 2)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
    end,
    __base = _base_0,
    __name = "Sprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Sprite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if self.world_obj then
        return love.graphics.draw(self.sprite, self.x - self.sprite:getWidth() / 2, self.y + self.world_obj.height - self.sprite:getHeight(), 0, self.scale, self.scale)
      else
        return love.graphics.draw(self.sprite, self.x, self.y, 0, self.scale, self.scale, self.sprite:getWidth() / 2, self.sprite:getHeight() / 2)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
    end,
    __base = _base_0,
    __name = "BackgroundSprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'BackgroundDrawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BackgroundSprite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if self.world_obj then
        return love.graphics.draw(self.sprite, self.x - self.sprite:getWidth() / 2, self.y + self.world_obj.height - self.sprite:getHeight(), 0, self.scale, self.scale)
      else
        return love.graphics.draw(self.sprite, self.x, self.y, 0, self.scale, self.scale, self.sprite:getWidth() / 2, self.sprite:getHeight() / 2)
      end
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.scale = 1
    end,
    __base = _base_0,
    __name = "ForegroundSprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'ForegroundDrawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ForegroundSprite = _class_0
end
do
  local _parent_0 = Sprite
  local _base_0 = {
    draw = function(self, msg, sender)
      __assert_with_msg(self.sprite, 'sprite')
      __assert_with_msg(self.quad, 'quad')
      __assert_with_msg(self.scale, 'scale')
      __assert_with_msg(self.x, 'x')
      __assert_with_msg(self.y, 'y')
      return love.graphics.draw(self.sprite, self.quad, self.x, self.y, 0, self.scale)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "QuadSprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  QuadSprite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self, msg, sender)
      local a = {
        0,
        0,
        0,
        0,
        255,
        255,
        255
      }
      local b = {
        0,
        0,
        1,
        0,
        255,
        255,
        255
      }
      local c = {
        0,
        0,
        1,
        1,
        255,
        255,
        255
      }
      local d = {
        0,
        0,
        0,
        1,
        255,
        255,
        255
      }
      self.mesh = love.graphics.newMesh({
        a,
        b,
        c,
        d
      }, "fan")
      return self.mesh:setTexture(self.sprite)
    end,
    physics_update = function(self, msg, sender)
      if not self.body then
        return 
      end
      if not self.shape then
        return 
      end
      if self.lerp_x1 == nil then
        self.lerp_x1_org, self.lerp_y1_org, self.lerp_x2_org, self.lerp_y2_org, self.lerp_x3_org, self.lerp_y3_org, self.lerp_x4_org, self.lerp_y4_org = self.body:getWorldPoints(self.shape:getPoints())
        self.lerp_x1, self.lerp_y1, self.lerp_x2, self.lerp_y2, self.lerp_x3, self.lerp_y3, self.lerp_x4, self.lerp_y4 = self.body:getWorldPoints(self.shape:getPoints())
        return 
      end
      self.lerp_x1_org = self.lerp_x1
      self.lerp_y1_org = self.lerp_y1
      self.lerp_x2_org = self.lerp_x2
      self.lerp_y2_org = self.lerp_y2
      self.lerp_x3_org = self.lerp_x3
      self.lerp_y3_org = self.lerp_y3
      self.lerp_x4_org = self.lerp_x4
      self.lerp_y4_org = self.lerp_y4
      self.lerp_x1, self.lerp_y1, self.lerp_x2, self.lerp_y2, self.lerp_x3, self.lerp_y3, self.lerp_x4, self.lerp_y4 = self.body:getWorldPoints(self.shape:getPoints())
    end,
    step = function(self, dt, sender)
      if self.x1 == nil or self.lerp_x1 == nil then
        return 
      end
      local r = __world_accumulator / PHYSICS_STEP
      self.x1 = self.lerp_x1_org * (1 - r) + self.lerp_x1 * r
      self.x2 = self.lerp_x2_org * (1 - r) + self.lerp_x2 * r
      self.x3 = self.lerp_x3_org * (1 - r) + self.lerp_x3 * r
      self.x4 = self.lerp_x4_org * (1 - r) + self.lerp_x4 * r
      self.y1 = self.lerp_y1_org * (1 - r) + self.lerp_y1 * r
      self.y2 = self.lerp_y2_org * (1 - r) + self.lerp_y2 * r
      self.y3 = self.lerp_y3_org * (1 - r) + self.lerp_y3 * r
      self.y4 = self.lerp_y4_org * (1 - r) + self.lerp_y4 * r
    end,
    draw = function(self, msg, sender)
      if self.x1 == nil or self.lerp_x1 == nil then
        self.x1, self.y1, self.x2, self.y2, self.x3, self.y3, self.x4, self.y4 = self.body:getWorldPoints(self.shape:getPoints())
      end
      local a = {
        self.x1 - self.x,
        self.y1 - self.y,
        0,
        0,
        255,
        255,
        255
      }
      local b = {
        self.x2 - self.x,
        self.y2 - self.y,
        1,
        0,
        255,
        255,
        255
      }
      local c = {
        self.x3 - self.x,
        self.y3 - self.y,
        1,
        1,
        255,
        255,
        255
      }
      local d = {
        self.x4 - self.x,
        self.y4 - self.y,
        0,
        1,
        255,
        255,
        255
      }
      self.mesh:setVertices({
        a,
        b,
        c,
        d
      })
      love.graphics.push()
      love.graphics.translate(self.x, self.y)
      love.graphics.scale(self.scale * 1.1, self.scale * 1.1)
      love.graphics.draw(self.mesh, 0, 0)
      return love.graphics.pop()
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.bboxed_quad_w = self.sprite:getWidth()
      self.bboxed_quad_h = self.sprite:getHeight()
      self.w = self.bboxed_quad_w
      self.h = self.bboxed_quad_h
    end,
    __base = _base_0,
    __name = "BBoxSprite",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable',
    'BBoxedQuad'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BBoxSprite = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    set_anim = function(self, msg, sender)
      self.curr_anim = self.anims[msg.anim_name]
      self.curr_anim:reset()
      self.curr_anim:setSpeed(1)
      return self.curr_anim:play()
    end,
    enqueue_anim = function(self, msg, sender)
      if self.curr_anim.playing then
        if msg.anim_name ~= self.curr_anim then
          return table.insert(self.queue, msg)
        end
      end
    end,
    step = function(self, dt, sender)
      self.curr_anim:update(dt)
      if not self.curr_anim.playing then
        local anim = table.remove(self.queue)
        if anim then
          self.curr_anim = self.anims[anim.anim_name]
          self.curr_anim:reset()
          self.curr_anim:setSpeed(1)
          return self.curr_anim:play()
        end
      end
    end,
    draw = function(self, msg, sender)
      __assert_with_msg(self.w, 'w')
      __assert_with_msg(self.h, 'h')
      __assert_with_msg(self.curr_anim, 'curr_anim')
      __assert_with_msg(self.facing_direction, 'facing_direction')
      __assert_with_msg(self.scale, 'scale')
      return self.curr_anim:draw(self.x - self.facing_direction * (self.w / 2), self.y - self.h / 2, 0, self.facing_direction * self.scale, self.scale)
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.anims = { }
      self.queue = { }
    end,
    __base = _base_0,
    __name = "SpriteAnimated",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'FacesDirection',
    'Drawable',
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SpriteAnimated = _class_0
end
local touchers = { }
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      for key, obj in pairs(touchers) do
        if obj == self then
          table.remove(touchers, key)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      return table.insert(touchers, self)
    end,
    __base = _base_0,
    __name = "Toucher",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Toucher = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if 50 < distance(self.x, self.y, player.x, player.y) then
        return 
      end
      __assert_with_msg(self.button_sprite, 'button_sprite')
      self.scale = 1
      local v = 55 + math.abs(math.sin(__get_time() * 5)) * 500
      love.graphics.setColor(v, v, v)
      love.graphics.draw(self.button_sprite, self.x, self.y - 80 - (math.sin(__get_time() * 10) * 5), math.sin(math.sin(__get_time() * 5)) * 0.1, self.scale, self.scale, self.button_sprite:getWidth() / 2, self.button_sprite:getWidth() / 2)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShowButtonWhenClose",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShowButtonWhenClose = _class_0
end
local __activatables = { }
do
  local _parent_0 = Component
  local _base_0 = {
    remove = function(self, msg, sender)
      for key, obj in pairs(__activatables) do
        if obj == self then
          table.remove(__activatables, key)
        end
      end
    end,
    activate = function(self, msg, sender) end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      table.insert(__activatables, self)
      self.button_sprite = __load_image("assets/gfx/button_down.png")
    end,
    __base = _base_0,
    __name = "Activatable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'ShowButtonWhenClose'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Activatable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, msg, sender)
      for key, o in pairs(touchers) do
        local _continue_0 = false
        repeat
          if o.room ~= self.room then
            _continue_0 = true
            break
          end
          if 32 < distance(self.x, self.y, o.x, o.y) then
            _continue_0 = true
            break
          end
          if (function()
            local _base_1 = o
            local _fn_0 = _base_1.id
            return function(...)
              return _fn_0(_base_1, ...)
            end
          end)() == self.id then
            _continue_0 = true
            break
          end
          self:send(self.id, 'touch', o.id)
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Touchable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Touchable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if not self.body then
        return 
      end
      local contacts = self.body:getContactList()
      for _, o in pairs(contacts) do
        local _continue_0 = false
        repeat
          if o:isTouching() then
            local fixtureA, fixtureB = o:getFixtures()
            local a = fixtureA:getUserData()
            local b = fixtureB:getUserData()
            if a.id == b.id then
              _continue_0 = true
              break
            end
            local category_a = fixtureA:getCategory()
            local category_b = fixtureB:getCategory()
            if category_a == SWORD_CATEGORY or category_b == SWORD_CATEGORY then
              _continue_0 = true
              break
            end
            if a ~= nil and a.id ~= nil and b ~= nil and b.id ~= nil then
              local nx, ny = o:getNormal()
              if a.id == self.id then
                local params = {
                  normal = {
                    -nx,
                    -ny
                  },
                  other_id = b.id,
                  other_faction = b.faction
                }
                self:send(self.id, 'contact', params)
              else
                local params = {
                  normal = {
                    nx,
                    ny
                  },
                  other_id = a.id,
                  other_faction = a.faction
                }
                self:send(self.id, 'contact', params)
              end
            end
          end
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Contactable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Contactable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      self.hp_pts = 5
    end,
    activate = function(self, msg, sender)
      __play_sound("assets/sound/pickup_health.wav")
      return self:send(msg.activator_id, "hp", {
        pts = self.hp_pts
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GivesHP",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GivesHP = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      __play_sound("assets/sound/pickup_health.wav")
      return self:send(msg.activator_id, "increase_max_hp", {
        pts = HP_PER_BALL
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PermanentHPImprovement",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PermanentHPImprovement = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      __play_sound("assets/sound/cured.wav")
      return self:send(msg.activator_id, "mixout", "Poisoned")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Cure",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Cure = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    touch = function(self, msg, sender)
      return self:send(msg, "mixin", "Poisoned")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Poison",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Poison = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      if msg.other_faction ~= nil then
        return self:send(msg.other_id, 'request_pickup', {
          activator_id = msg.other_id,
          pickup_class_name = self.pickup_class_name
        })
      end
    end,
    approve_pickup = function(self, msg, sender)
      if self.picked_up then
        return 
      end
      self:send(self.id, "activate", {
        activator_id = sender
      })
      self:send(self.id, "remove")
      self.picked_up = true
      if self.pickup_message and player.id == msg.other_id then
        __message = self.pickup_message
        __message_remove_time = __get_time() + __message_duration
        __message_size = 1
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Pickupable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Pickupable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    request_pickup = function(self, msg, sender)
      msg.other_id = self.id
      msg.requestor = sender
      if msg.pickup_class_name and not self:is_mixed_in(msg.pickup_class_name) then
        return 
      end
      return self:send(sender, 'approve_pickup', msg)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Pickupper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Pickupper = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      self:send(msg.other_id, "set_vel", {
        0,
        -1100
      })
      return self:send(msg.other_id, "set_pos", {
        self.x,
        self.y - 50
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PushesVertically",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PushesVertically = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.last_scream + self.scream_time < __get_time() then
        __assert_with_msg(self.scream_sound_file, 'scream_sound_file')
        self.last_scream = __get_time()
        return __play_sound(self.scream_sound_file)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_scream = 0
      self.scream_time = 3
    end,
    __base = _base_0,
    __name = "Screamer",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Screamer = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.last_random_jump < __get_time() and self.touching_ground then
        self.last_random_jump = __get_time() + __random() * 2 + 1
        self.body:applyLinearImpulse(0, -600)
        return __play_sound("assets/sound/monster_excite.wav")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_random_jump = __random() * 2
    end,
    __base = _base_0,
    __name = "RandomJumper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RandomJumper = _class_0
end
do
  local needs
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, dt, sender)
      if __get_time() < self.last_attack + self.attack_cooldown_time and self.its_hit_time then
        local b = self.spine_skeleton:findBone('weapon')
        local rotation = b:getWorldRotationX()
        local rads = (rotation * 3.146) / 180
        local length = b.data.length * (self.sword_length_multiplier or 1.3)
        local r = #self.swoosh_polys / 20.0
        r = r * r
        if 1 < r then
          r = 1
        end
        r = 1 - r
        local push_x = length * (r) * math.cos(rads)
        local push_y = length * (r) * math.sin(rads)
        local new_x = self.x + b.worldX * b.scaleX + push_x
        local new_y = self.y + self.spine_h_adjustment + b.worldY * b.scaleY + push_y
        local new_xb = new_x + length * math.cos(rads) - push_x
        local new_yb = new_y + length * math.sin(rads) - push_y
        if self.swoosh_point[1] ~= 0 and self.swoosh_point[2] ~= 0 then
          table.insert(self.swoosh_polys, {
            self.swoosh_point[1],
            self.swoosh_point[2],
            self.swoosh_pointb[1],
            self.swoosh_pointb[2],
            new_xb,
            new_yb,
            new_x,
            new_y
          })
        end
        self.swoosh_point[1] = new_x
        self.swoosh_point[2] = new_y
        self.swoosh_pointb[1] = new_xb
        self.swoosh_pointb[2] = new_yb
      end
      local total = #self.swoosh_polys
      local decay = (self.last_attack + self.attack_cooldown_time * 0.7 - __get_time())
      if 0 < decay then
        for key, poly in pairs(self.swoosh_polys) do
          love.graphics.setColor(255, 255, 255, (key / total) * decay * 6050)
          love.graphics.polygon('fill', poly)
        end
      end
      return love.graphics.setColor(255, 255, 255)
    end,
    end_of_anim = function(self, msg, sender)
      self.swoosh_polys = { }
      self.swoosh_point[1] = 0
      self.swoosh_point[2] = 0
    end,
    anim_event = function(self, msg, sender)
      if msg.event_name == 'hit_end' or msg.event_name == 'hit_start' then
        self.swoosh_polys = { }
        self.swoosh_point[1] = 0
        self.swoosh_point[2] = 0
      end
    end,
    cmd_primary_pressed = function(self, msg, sender)
      if __get_time() < self.last_attack + self.attack_cooldown_time then
        return 
      end
      self.swoosh_polys = { }
      self.swoosh_point[1] = 0
      self.swoosh_point[2] = 0
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.spine_anim_speed = 1
      self.swoosh_polys = { }
      self.swoosh_point = {
        0,
        0
      }
      self.swoosh_pointb = {
        0,
        0
      }
    end,
    __base = _base_0,
    __name = "SwordSwoosher",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  needs = {
    'SpineSkeleton',
    'SpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SwordSwoosher = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    start_attack = function(self, msg, sender)
      self.dmg_bonus = msg.dmg_bonus or 1
    end,
    sword_contact = function(self, msg, sender)
      if self.its_hit_time then
        __play_sound("assets/sound/weapon_clash.wav")
        if self.curr_anim == 'attack_2_greatsword' then
          self:send(self.id, 'set_anim', {
            anim_name = 'attack_uppercut_blocked',
            force = true
          })
        else
          self:send(self.id, 'set_anim', {
            anim_name = 'attack_blocked',
            force = true
          })
        end
        self.its_hit_time = false
        local magnitude = 1
        for i = 1, 10 do
          local o = Fire()
          self:send(o.id, 'set_pos', msg.pos)
          self:send(o.id, 'set_vel', random_direction_cosmetic(magnitude))
        end
      end
    end,
    attack_blocked = function(self, msg, sender)
      if self.curr_anim == 'attack_2_greatsword' then
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_uppercut_blocked'
        })
      else
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_blocked'
        })
      end
      self.its_hit_time = false
      self.last_attack = __get_time() + 1
    end,
    anim_event = function(self, msg, sender)
      if msg.event_name == "hit_start" then
        if not self.its_hit_time then
          __play_sound("assets/sound/longsword_attack.wav")
        end
        self.its_hit_time = true
      elseif msg.event_name == "hit_end" then
        self.its_hit_time = false
      end
    end,
    end_of_anim = function(self, msg, sender)
      self.its_hit_time = false
      if self.attack_cooldown_time == nil then
        self.last_attack = 0
      end
      self.objects_hit = { }
      self.dmg_bonus = 0
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_attack = 0
      self.attack_cooldown_time = nil
      self.dmg_pts = 25
      self.attack_range = 80
      self.its_hit_time = false
      self.objects_hit = { }
    end,
    __base = _base_0,
    __name = "SpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.weapon_body then
        if self.its_hit_time then
          local contacts = self.weapon_body:getContactList()
          for _, o in pairs(contacts) do
            local _continue_0 = false
            repeat
              if not o:isTouching() then
                _continue_0 = true
                break
              end
              local fixtureA, fixtureB = o:getFixtures()
              local a = fixtureA:getUserData()
              local b = fixtureB:getUserData()
              if a ~= nil and a.id ~= nil and b ~= nil and b.id ~= nil then
                local nx, ny = o:getNormal()
                local x, y = o:getPositions()
                if a.id == self.id then
                  local params = {
                    normal = {
                      -nx,
                      -ny
                    },
                    other_id = b.id,
                    other_faction = b.faction,
                    pos = {
                      x,
                      y
                    }
                  }
                  self:send(self.id, 'attack_collide', {
                    a = a,
                    b = b,
                    category_a = fixtureA:getCategory(),
                    category_b = fixtureB:getCategory(),
                    collision_params = params,
                    dmg_bonus = self.dmg_bonus or 1
                  })
                else
                  local params = {
                    normal = {
                      nx,
                      ny
                    },
                    other_id = a.id,
                    other_faction = a.faction,
                    pos = {
                      x,
                      y
                    }
                  }
                  self:send(self.id, 'attack_collide', {
                    a = b,
                    b = a,
                    category_a = fixtureB:getCategory(),
                    category_b = fixtureA:getCategory(),
                    collision_params = params,
                    dmg_bonus = self.dmg_bonus or 1
                  })
                end
              end
              _continue_0 = true
            until true
            if not _continue_0 then
              break
            end
          end
        end
        self.weapon_body:destroy()
        self.weapon_body = nil
      end
      if self.its_hit_time then
        local bbox = self.spine_skeleton:getAttachment(self.spine_skeleton_slot_name, self.spine_skeleton_bbox_name)
        __assert_with_msg(bbox, 'need bbox')
        local bounds = spine.SkeletonBounds.new()
        bounds:update(self.spine_skeleton, true)
        local weapon_poly = bounds:getPolygon(bbox)
        if not weapon_poly then
          return 
        end
        __assert_with_msg(weapon_poly, 'need poly')
        self.weapon_body = love.physics.newBody(self.room.world, 0, 0, "dynamic")
        __assert_with_msg(self.weapon_body, 'need weapon body')
        self.weapon_shape = love.physics.newPolygonShape(weapon_poly)
        self.weapon_fixture = love.physics.newFixture(self.weapon_body, self.weapon_shape, 1)
        self.weapon_fixture:setUserData(self)
        self.weapon_fixture:setFriction(1)
        self.weapon_fixture:setMask(REGULAR_CATEGORY)
        return self.weapon_fixture:setCategory(SWORD_CATEGORY)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.spine_skeleton_slot_name = 'sword'
      self.spine_skeleton_bbox_name = 'bbox_greatsword'
    end,
    __base = _base_0,
    __name = "SwordSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SwordSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    start_attack = function(self, msg, sender)
      if self.crouching then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_stab'
        })
      else
        if self.idle_anim == 'idle_2_greatsword' then
          return self:send(self.id, 'set_anim', {
            anim_name = 'attack_2_greatsword'
          })
        else
          return self:send(self.id, 'set_anim', {
            anim_name = 'attack_1_greatsword'
          })
        end
      end
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_greatsword' then
        self.idle_anim = 'idle_2_greatsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_greatsword' then
        self.idle_anim = 'idle_1_greatsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_3_greatsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    attack_collide_confirm = function(self, msg, sender)
      if self.curr_anim == 'attack_2_greatsword' then
        self:send(msg.b.id, 'set_pos', {
          msg.b.x,
          msg.b.y - 50
        })
        return self:send(msg.b.id, 'set_vel', {
          500 * self.facing_direction + self.x_vel,
          -1200 + self.y_vel
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GreatSwordSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GreatSwordSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.last_charge_up = 0
      self.charge_up_duration = 3
      local img = __load_image("assets/gfx/debris.png")
      self.charge_up_debris_ps = love.graphics.newParticleSystem(img, 30)
      self.charge_up_debris_ps:setParticleLifetime(0.1, 1.5)
      self.charge_up_debris_ps:setAreaSpread('normal', 5, 5)
      self.charge_up_debris_ps:setSizes(0.5, 0.7, 1.0)
      self.charge_up_debris_ps:setSpin(1, 5)
      self.charge_up_debris_ps:setRotation(-100, 100)
      self.charge_up_debris_ps:setLinearAcceleration(0, -300, 0, -350)
      img = __load_image("assets/gfx/power_bubble.png")
      self.charge_up_ps = love.graphics.newParticleSystem(img, 100)
      self.charge_up_ps:setParticleLifetime(0.1, 0.4)
      self.charge_up_ps:setAreaSpread('normal', 10, 20)
      self.charge_up_ps:setSizes(0.1, 0.3, 0.4)
      self.charge_up_ps:setSpin(1, 5)
      self.charge_up_ps:setRotation(-100, 100)
      self.charge_up_ps:setLinearAcceleration(0, -200, 0, -350)
      return self.charge_up_ps:setColors(255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0)
    end,
    start_attack = function(self, msg, sender)
      if self.crouching then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_stab'
        })
      else
        if self.idle_anim == 'idle_2_greatsword' then
          return self:send(self.id, 'set_anim', {
            anim_name = 'attack_2_greatsword'
          })
        else
          return self:send(self.id, 'set_anim', {
            anim_name = 'attack_1_greatsword'
          })
        end
      end
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_greatsword' then
        self.idle_anim = 'idle_2_greatsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_greatsword' then
        self.idle_anim = 'idle_1_greatsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_3_greatsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    draw = function(self, msg, sender)
      if self.last_charge_up == 0 then
        return 
      else
        love.graphics.draw(self.charge_up_ps)
        return love.graphics.draw(self.charge_up_debris_ps)
      end
    end,
    step = function(self, dt, sender)
      self.charge_up_ps:setPosition(self.x, self.y)
      self.charge_up_ps:update(dt)
      local _, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, {
        self.x,
        self.y + 1000
      })
      if hit_y ~= nil then
        self.charge_up_debris_ps:setPosition(self.x, hit_y)
      else
        self.charge_up_debris_ps:setPosition(self.x, self.y)
      end
      self.charge_up_debris_ps:update(dt)
      if self.last_charge_up == 0 then
        return 
      elseif self.last_charge_up < __get_time() then
        self:send(self.id, "mixin", "FlashesYellow")
      end
      if self.last_charge_up < __get_time() + 3 then
        local r = math.min(1 - (self.last_charge_up - (__get_time() + 3)) / self.charge_up_duration, 2)
        self.charge_up_debris_ps:setParticleLifetime(0.1 * r, 0.7 * r)
        self.charge_up_debris_ps:setSizes(0.2 * r, 0.3 * r, 0.5 * r)
        self.charge_up_debris_ps:setAreaSpread('normal', 20 * r * r, 5)
        self.charge_up_debris_ps:emit(1)
      end
      if self.last_charge_up < __get_time() + 2 then
        local r = (1 - (self.last_charge_up - (__get_time() + 2)) / self.charge_up_duration)
        self.charge_up_debris_ps:setSizes(0.2 * r, 0.3 * r, 0.5 * r)
        self.charge_up_debris_ps:setAreaSpread('normal', 5 * r * r, 1 * r)
        return self.charge_up_ps:emit((0.8 + r))
      end
    end,
    start_charge_up = function(self, msg, sender)
      self.last_charge_up = __get_time() + self.charge_up_duration
    end,
    cmd_primary_pressed = function(self, dt, sender)
      return self:send(self.id, 'start_charge_up', { })
    end,
    cmd_primary_released = function(self, dt, sender)
      if __get_time() < self.last_attack + self.attack_cooldown_time then
        self.last_charge_up = 0
        self.attack_queued = true
        return 
      end
      self.last_attack = __get_time()
      if self.last_charge_up < __get_time() + 2 then
        self:send(self.id, 'start_attack', {
          dmg_bonus = 1 + (1 - (self.last_charge_up - __get_time()) / self.charge_up_duration) * 1.5
        })
      else
        self:send(self.id, 'start_attack', { })
      end
      self.last_charge_up = 0
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SuperGreatSwordSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SuperGreatSwordSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    start_attack = function(self, msg, sender)
      return self:send(self.id, 'set_anim', {
        anim_name = 'attack_1_greatsword'
      })
    end,
    end_of_anim = function(self, msg, sender)
      self.idle_anim = 'idle_2_greatsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DumbGreatSwordSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DumbGreatSwordSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_primary_pressed = function(self, dt, sender)
      if __get_time() < self.last_attack + self.attack_cooldown_time then
        self.attack_queued = true
        return 
      end
      self.last_attack = __get_time()
      return self:send(self.id, 'start_attack', { })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_attack = 0
      self.attack_cooldown_time = 0.9
      self.dmg_pts = 25
      self.attack_range = 80
      self.primary_down = false
      self.attack_queued = false
    end,
    __base = _base_0,
    __name = "AttackerP",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'FacesDirection'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AttackerP = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = { }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_attack = 0
      self.attack_cooldown_time = 0.9
      self.dmg_pts = 25
      self.attack_range = 80
      self.primary_down = false
      self.attack_queued = false
    end,
    __base = _base_0,
    __name = "AttackerP2",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'FacesDirection'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AttackerP2 = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.last_attack = 0
      self.attack_cooldown_time = 0.15
      self.dmg_pts = 25
      self.attack_range = 60
    end,
    cmd_primary_pressed = function(self, msg, sender)
      if __get_time() < self.last_attack + self.attack_cooldown_time then
        return 
      end
      self.last_attack = __get_time()
      if self.crouching then
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_stab'
        })
      else
        self:send(self.id, 'set_anim', {
          anim_name = 'attack'
        })
      end
      return self:send(self.id, 'start_attack', { })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Attacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'FacesDirection'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Attacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    start_attack = function(self, msg, sender)
      for key, o in pairs(__damageables) do
        local _continue_0 = false
        repeat
          if o.room ~= self.room then
            _continue_0 = true
            break
          end
          if o.id == self.id then
            _continue_0 = true
            break
          end
          if o.faction == self.faction then
            _continue_0 = true
            break
          end
          if self.attack_range < distance(self.x, self.y, o.x, o.y) then
            _continue_0 = true
            break
          end
          self:send(o.id, 'execute_attack', {
            pts = self.dmg_pts * (msg.dmg_bonus or 1),
            atk_origin = {
              o.x,
              o.y
            }
          })
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SimpleAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Attacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SimpleAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_secondary = function(self, msg, sender)
      if __get_time() < self.last_throw + self.throw_cooldown_time then
        return 
      end
      if self.throw_payload == nil or self.throw_payload == 0 then
        return 
      end
      self.throw_payload = self.throw_payload - 1
      self.last_throw = __get_time()
      local target_pos = {
        self.x + 50 * self.facing_direction,
        self.y - 30
      }
      if self.crouching then
        target_pos = {
          self.x + 50 * self.facing_direction,
          self.y - 10
        }
      end
      if __position_is_clear(self.room, {
        self.x,
        self.y
      }, target_pos) then
        __assert_with_msg(self.throwing_object_class, 'need throwing class')
        __play_sound("assets/sound/throw.wav")
        self:send(self.id, 'set_anim', {
          anim_name = self.throw_anim or 'throw'
        })
        local b = self:throwing_object_class()
        self:send(b.id, 'set_pos', target_pos)
        return self:send(b.id, 'set_vel', {
          self.throw_speed * self.facing_direction + self.x_vel,
          0
        })
      end
    end,
    throw = function(self, msg, sender)
      local target_pos = {
        self.x + self.facing_direction * 40,
        self.y
      }
      local hit_x, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, target_pos)
      if hit_x then
        target_pos[1] = hit_x
        target_pos[2] = hit_y
      end
      local o = msg.cls()
      self:send(o.id, 'set_pos', target_pos)
      return self:send(o.id, 'set_vel', msg.vel)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_throw = 0
      self.throw_cooldown_time = 0.3
    end,
    __base = _base_0,
    __name = "Thrower",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'FacesDirection'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Thrower = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.old_throw_payload = self.throw_payload
      self.throw_anim = 'throw'
      self.throw_icon = __load_image("assets/gfx/landmine.png")
      self.throw_cooldown_time = 0.5
      self.throwing_object_class = Landmine
      self.throw_speed = 500
      self:send(self.id, "mixout", "DartBlower")
      return self:send(self.id, "mixout", "KunaiThrower")
    end,
    mixed_out = function(self, msg, sender)
      return self:send(self.id, 'drop_ball', {
        name = 'Tntbox',
        throw_payload = self.old_throw_payload
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "LandmineLayer",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Thrower'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  LandmineLayer = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.old_throw_payload = self.throw_payload
      self.throw_anim = 'throw'
      self.throw_icon = __load_image("assets/gfx/kunai.png")
      self.throwing_object_class = ThrowingKunai
      self.throw_speed = 2500
      self.throw_cooldown_time = 0.3
      self:send(self.id, "mixout", "DartBlower")
      return self:send(self.id, "mixout", "LandmineLayer")
    end,
    mixed_out = function(self, msg, sender)
      return self:send(self.id, 'drop_ball', {
        name = 'Kunaibox',
        throw_payload = self.old_throw_payload
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "KunaiThrower",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Thrower',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  KunaiThrower = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.old_throw_payload = self.throw_payload
      self.throw_anim = 'blow'
      self.throw_icon = __load_image("assets/gfx/zdart.png")
      self.throwing_object_class = ZDart
      self.throw_speed = 8000
      self.throw_cooldown_time = 0.3
      self:send(self.id, "mixout", "KunaiThrower")
      return self:send(self.id, "mixout", "LandmineLayer")
    end,
    mixed_out = function(self, msg, sender)
      return self:send(self.id, 'drop_ball', {
        name = 'Zpipebox',
        throw_payload = self.old_throw_payload
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DartBlower",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Thrower',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DartBlower = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_down_pressed = function(self, msg, sender)
      if __get_time() < self.last_activate + 1 then
        return 
      end
      for key, a in pairs(__activatables) do
        local _continue_0 = false
        repeat
          if a.room ~= self.room then
            _continue_0 = true
            break
          end
          if 40 < distance(self.x, self.y, a.x, a.y) then
            _continue_0 = true
            break
          end
          if (function()
            local _base_1 = a
            local _fn_0 = _base_1.id
            return function(...)
              return _fn_0(_base_1, ...)
            end
          end)() == self.id then
            _continue_0 = true
            break
          end
          self:send(a.id, 'activate', {
            activator_id = self.id
          })
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_activate = 0
    end,
    __base = _base_0,
    __name = "Activator",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Activator = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_left_released = function(self, msg, sender)
      if not self.body then
        return 
      end
      self.last_button_release = __get_time()
      if self.touching_ground then
        if self.curr_anim == 'run' then
          return self:send(self.id, 'set_anim', {
            anim_name = self.idle_anim
          })
        end
      end
    end,
    cmd_right_released = function(self, msg, sender)
      if not self.body then
        return 
      end
      self.last_button_release = __get_time()
      if self.touching_ground then
        if self.curr_anim == 'run' then
          return self:send(self.id, 'set_anim', {
            anim_name = self.idle_anim
          })
        end
      end
    end,
    touch_ground = function(self, msg, sender)
      if not self.left_down and not self.right_down then
        return self:send(self.id, 'enqueue_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    not_touching_ground = function(self, msg, sender)
      self.queue = { }
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == self.idle_anim then
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif self.touching_ground and not self.left_down and not self.right_down then
        return self:send(self.id, 'enqueue_anim', {
          anim_name = self.idle_anim
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_button_release = 0
      self.idle_anim = 'idle_twohand'
    end,
    __base = _base_0,
    __name = "AnimatedIdler",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AnimatedIdler = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'run'
        })
      end
    end,
    cmd_left = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'run'
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "AnimatedRunner",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper',
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AnimatedRunner = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'fly'
        })
      end
    end,
    cmd_left = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'fly'
        })
      end
    end,
    end_of_anim = function(self, msg, sender)
      if not (self.touching_ground) then
        return self:send(self.id, 'set_anim', {
          anim_name = 'fly'
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "AnimatedFlier",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper',
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AnimatedFlier = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'walk'
        })
      end
    end,
    cmd_left = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        return self:send(self.id, etype, {
          anim_name = 'walk'
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "AnimatedWalker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper',
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AnimatedWalker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    anim_event = function(self, msg, sender)
      if startswith(msg.event_name, 'sound_footstep_big') then
        return self.body:applyLinearImpulse(6000 * self.facing_direction, 0)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "MovesOnFootstep",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MovesOnFootstep = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.touching_ground then
        if __cosmetic_random() < 0.05 then
          return self:send(Fire().id, 'set_pos', {
            self.x,
            self.y + 20
          })
        end
      end
    end,
    cmd_left = function(self, msg, sender)
      if self.touching_ground then
        if __cosmetic_random() < 0.05 then
          return self:send(Fire().id, 'set_pos', {
            self.x,
            self.y + 20
          })
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "FlameWalker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FlameWalker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    start_attack = function(self, msg, sender)
      __play_sound("assets/sound/fire_punch.wav")
      local target_pos = {
        self.x + 50 * self.facing_direction,
        self.y - 45
      }
      local hit_x, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, target_pos)
      if hit_x ~= nil then
        target_pos[1], target_pos[2] = hit_x, hit_y
      end
      local vel = {
        10 * self.facing_direction,
        0
      }
      for i = 1, 1 do
        local o = Fire()
        o.scale = 2
        self:send(o.id, 'set_pos', target_pos)
        self:send(o.id, 'set_vel', vel)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "FlamePuncher",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  FlamePuncher = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        if 90 < math.abs(self.x_vel) then
          return self:send(self.id, etype, {
            anim_name = 'run'
          })
        else
          return self:send(self.id, etype, {
            anim_name = 'walk'
          })
        end
      end
    end,
    cmd_left = function(self, msg, sender)
      if self.touching_ground then
        local etype
        if self.curr_anim == self.idle_anim then
          etype = 'set_anim'
        else
          etype = 'enqueue_anim'
        end
        if 90 < math.abs(self.x_vel) then
          return self:send(self.id, etype, {
            anim_name = 'run'
          })
        else
          return self:send(self.id, etype, {
            anim_name = 'walk'
          })
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "AnimatedRunWalker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper',
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AnimatedRunWalker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_right = function(self, msg, sender)
      return self:send(self.id, 'move_right', self.walk_speed * ((function()
        if self.touching_ground then
          return 1
        else
          return self.air_control
        end
      end)()))
    end,
    cmd_left = function(self, msg, sender)
      return self:send(self.id, 'move_left', self.walk_speed * ((function()
        if self.touching_ground then
          return 1
        else
          return self.air_control
        end
      end)()))
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.walk_speed = 100
      self.air_control = 1
    end,
    __base = _base_0,
    __name = "Controlled",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper',
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Controlled = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      return self:send(sender, 'enter_room', {
        ['door'] = self
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Doorable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Activatable',
    'RoomOccupier'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Doorable = _class_0
end
local clamp_velocity
clamp_velocity = function(x_vel, y_vel, body, max_speed)
  if max_speed < math.abs(x_vel) then
    return body:setLinearVelocity(sign(x_vel) * max_speed, y_vel)
  end
end
local __clamp_camera
__clamp_camera = function(self)
  local left_hand_side = 0
  local right_hand_side = current_room.map.width * current_room.map.tilewidth - windowWidth
  if self._x < left_hand_side then
    self._x = left_hand_side
  elseif right_hand_side < self._x then
    self._x = right_hand_side
  end
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.touching_ground then
        return self.body:applyLinearImpulse(0, -math.abs(__random() * 500))
      else
        if self.hover_height < self.y then
          return self.body:applyLinearImpulse(0, -100)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.hover_height = 300
    end,
    __base = _base_0,
    __name = "Hovers",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Hovers = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    make_bbox = function(self, msg, sender)
      __assert_with_msg(self.room, 'room')
      __assert_with_msg(self.bbox_radius, 'bbox_radius')
      __assert_with_msg(self.restitution, 'res')
      __assert_with_msg(self.mass, 'mass')
      __assert_with_msg(self.friction, 'f')
      local bbox_type = 'dynamic'
      if self.bbox_type then
        bbox_type = self.bbox_type
      end
      self.body = love.physics.newBody(self.room.world, self.x, self.y, bbox_type)
      self.shape = love.physics.newCircleShape(self.bbox_radius)
      self.fixture = love.physics.newFixture(self.body, self.shape, 1)
      self.fixture:setRestitution(self.restitution)
      self.fixture:setUserData(self)
      self.fixture:setFriction(self.friction)
      self.fixture:setCategory(DMG_CATEGORY)
      self.body:setMass(self.mass)
      self.body:setAngularDamping(1)
      self.lerp_x = self.body:getX()
      self.lerp_y = self.body:getY()
      self.lerp_x_org = self.lerp_x
      self.lerp_y_org = self.lerp_y
      self.lerp_angle = self.body:getAngle()
      self.lerp_angle_org = self.body:getAngle()
      self.x = self.lerp_x
      self.y = self.lerp_y
    end,
    physics_update = function(self, dt, sender)
      if not self.body then
        return 
      end
      __assert_with_msg(self.body, 'body')
      self.last_lerp_time = __get_time()
      self.lerp_x_org = self.lerp_x or self.body:getX()
      self.lerp_y_org = self.lerp_y or self.body:getY()
      self.lerp_x = self.body:getX()
      self.lerp_y = self.body:getY()
      self.lerp_angle_org = self.angle
      self.lerp_angle = self.body:getAngle()
      self.x_vel, self.y_vel = self.body:getLinearVelocity()
      clamp_velocity(self.x_vel, self.y_vel, self.body, self.speed_max)
      if self.left_down or self.right_down then
        self.body:setAngularDamping(1)
        self.body:setFixedRotation(false)
      end
      if self.touching_ground then
        return self.body:applyLinearImpulse(0, 30)
      end
    end,
    step = function(self, dt, sender)
      if self.lerp_x == nil then
        if self.body then
          self.x = self.body:getX()
          self.y = self.body:getY()
          self.angle = self.body:getAngle()
        else
          self.x = 0
          self.y = 0
          self.angle = 0
        end
      else
        local r = __world_accumulator / PHYSICS_STEP
        self.x = self.lerp_x_org * (1 - r) + self.lerp_x * r
        self.y = self.lerp_y_org * (1 - r) + self.lerp_y * r
        if self.lerp_angle_org then
          self.angle = self.lerp_angle_org * (1 - r) + self.lerp_angle * r
        end
      end
    end,
    cmd_left_released = function(self, msg, sender)
      if not self.body or self.right_down then
        return 
      end
      self.body:setAngularVelocity(0)
      self.body:setAngularDamping(100)
      return self.body:setFixedRotation(true)
    end,
    cmd_right_released = function(self, msg, sender)
      if not self.body or self.left_down then
        return 
      end
      self.body:setAngularVelocity(0)
      self.body:setAngularDamping(100)
      return self.body:setFixedRotation(true)
    end,
    touch_ground = function(self, msg, sender)
      if not self.left_down and not self.right_down then
        self.body:setAngularVelocity(0)
        self.body:setAngularDamping(100)
        return self.body:setFixedRotation(true)
      else
        self.body:setAngularDamping(1)
        return self.body:setFixedRotation(false)
      end
    end,
    set_vel = function(self, msg, sender)
      return self.body:applyLinearImpulse(msg[1], msg[2])
    end,
    move_right = function(self, speed, sender)
      if not self.body then
        return 
      end
      if self.its_hit_time == true then
        return 
      end
      return self.body:applyLinearImpulse(speed, 0)
    end,
    move_left = function(self, speed, sender)
      if not self.body then
        return 
      end
      if self.its_hit_time == true then
        return 
      end
      return self.body:applyLinearImpulse(-speed, 0)
    end,
    set_pos = function(self, msg, sender)
      if self.body then
        self.body:setX(msg[1])
        self.body:setY(msg[2])
      end
      self.x = msg[1]
      self.y = msg[2]
      self.lerp_x = msg[1]
      self.lerp_y = msg[2]
      self.lerp_x_org = msg[1]
      self.lerp_y_org = msg[2]
    end,
    set_room = function(self, msg, sender)
      self.body:destroy()
      self.body = nil
      return self:send(self.id, 'make_bbox')
    end,
    remove = function(self, msg, sender)
      if self.body then
        self.body:destroy()
        self.body = nil
      end
    end,
    attach = function(self, msg, sender)
      local joint = love.physics.newRopeJoint(self.body, msg.body, self.x, self.y, msg.x, msg.y, msg.length, true)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.mass = 5
      self.friction = 6
      self.restitution = 0.2
      self.bbox_radius = 10
      self.speed_max = 300
      self.last_lerp_time = 0
      self.angle = 0
      return self:send(self.id, 'make_bbox')
    end,
    __base = _base_0,
    __name = "BBoxed",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BBoxed = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    make_bbox = function(self, msg, sender)
      __assert_with_msg(self.room, 'room')
      __assert_with_msg(self.bbox_radius, 'bbox_radius')
      __assert_with_msg(self.restitution, 'restitution')
      __assert_with_msg(self.mass, 'mass')
      __assert_with_msg(self.friction, 'friction')
      self.body = love.physics.newBody(self.room.world, self.x, self.y, "dynamic")
      self.shape = love.physics.newRectangleShape(0, 0, self.w, self.h)
      self.fixture = love.physics.newFixture(self.body, self.shape, 1)
      self.fixture:setRestitution(self.restitution)
      self.fixture:setUserData(self)
      self.fixture:setFriction(self.friction)
      self.fixture:setCategory(DMG_CATEGORY)
      self.body:setMass(self.mass)
      self.body:setAngularDamping(1)
      self.body:setFixedRotation(true)
      return self.body:setFixedRotation(false)
    end,
    set_pos = function(self, msg, sender)
      if self.body then
        self.body:setX(msg[1])
        return self.body:setY(msg[2])
      end
    end,
    set_room = function(self, msg, sender)
      self.body:destroy()
      self.body = nil
      return self:send(self.id, 'make_bbox')
    end,
    remove = function(self, msg, sender)
      if self.body then
        self.body:destroy()
        self.body = nil
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.mass = 5
      self.friction = 6
      self.restitution = 0.2
      self.bbox_radius = 10
      self.speed_max = 300
      return self:send(self.id, 'make_bbox')
    end,
    __base = _base_0,
    __name = "RectangleBBox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RectangleBBox = _class_0
end
do
  local _parent_0 = BBoxed
  local _base_0 = {
    init = function(self, msg, sender)
      return newbbox_quad(self)
    end,
    make_bbox = function(self, msg, sender)
      return newbbox_quad(self)
    end,
    physics_update = function(self, dt, sender)
      return _parent_0.physics_update(self, dt, sender)
    end,
    step = function(self, dt, sender)
      return _parent_0.step(self, dt, sender)
    end,
    set_vel = function(self, msg, sender)
      return _parent_0.set_vel(self, msg, sender)
    end,
    move_right = function(self, speed, sender)
      return _parent_0.move_right(self, speed, sender)
    end,
    move_left = function(self, speed, sender)
      return _parent_0.move_left(self, speed, sender)
    end,
    set_pos = function(self, msg, sender)
      return _parent_0.set_pos(self, msg, sender)
    end,
    set_room = function(self, msg, sender)
      self.body:destroy()
      self.body = nil
      return newbbox_quad(self)
    end,
    remove = function(self, msg, sender)
      return _parent_0.remove(self, msg, sender)
    end,
    attach = function(self, msg, sender)
      return _parent_0.attach(self, msg, sender)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "BBoxedQuad",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BBoxedQuad = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if not self.body then
        return 
      end
      __assert_with_msg(self.body, 'body')
      local touch
      touch = function()
        if not self.touching_ground then
          self:send(self.id, 'touch_ground')
        end
        self.touching_ground = true
      end
      local _, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, {
        self.x,
        self.y + 40
      })
      if hit_y ~= nil then
        touch()
        return 
      end
      _, hit_y = __find_closest_point(self.room, {
        self.x + 10,
        self.y
      }, {
        self.x + 10,
        self.y + 40
      })
      if hit_y ~= nil then
        touch()
        return 
      end
      _, hit_y = __find_closest_point(self.room, {
        self.x - 10,
        self.y
      }, {
        self.x - 10,
        self.y + 40
      })
      if hit_y ~= nil then
        touch()
        return 
      end
      if self.touching_ground then
        self:send(self.id, 'not_touching_ground')
      end
      self.touching_ground = false
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.touching_ground = false
    end,
    __base = _base_0,
    __name = "TouchingGroundChecker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'BBoxed'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  TouchingGroundChecker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_up_released = function(self, msg, sender)
      self.jump_down = false
    end,
    cmd_up = function(self, msg, sender)
      if self.touching_ground and self.last_jump_time + self.jump_cooldown < __get_time() then
        if not self.jump_down then
          self.jump_down = true
          self.last_jump_time = __get_time()
          self:send(self.id, 'jump')
          return self:send(self.id, 'set_anim', {
            anim_name = 'jump'
          })
        end
      end
    end,
    jump = function(self, msg, sender)
      return self.body:applyLinearImpulse(0, -self.jump_impulse)
    end,
    step = function(self, dt, sender)
      if not self.body then
        return 
      end
      if self.jump_down then
        self.body:applyLinearImpulse(0, dt * -1500)
        if self.last_jump_time + self.jump_cooldown < __get_time() then
          self:send(self.id, 'set_anim', {
            anim_name = 'jump_flip'
          })
          self.jump_down = false
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.last_jump_time = 0
      self.jump_impulse = 400
      self.jump_cooldown = 0.4
      self.jump_down = false
    end,
    __base = _base_0,
    __name = "Jumper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'TouchingGroundChecker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Jumper = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    cmd_up_released = function(self, msg, sender)
      if not self.body then
        return 
      end
      if not self.touching_ground and not self.double_jumped and self.last_jump_time + self.jump_cooldown < __get_time() then
        self.body:applyLinearImpulse(0, -self.jump_impulse)
        self.double_jumped = true
        self:send(Smoke().id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(self.id, 'set_anim', {
          anim_name = 'jump_flip'
        })
        return __play_sound("assets/sound/double_jump.wav")
      end
    end,
    touch_ground = function(self, msg, sender)
      self.double_jumped = false
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.double_jumped = false
    end,
    __base = _base_0,
    __name = "DoubleJumper",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Jumper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DoubleJumper = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_start = function(self, msg, sender)
      local max_dist = 400
      local hit_x, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, {
        self.x,
        self.y + max_dist
      })
      if hit_y ~= nil then
        local dist = distance(self.x, self.y, hit_x, hit_y)
        dist = dist / max_dist
        if 1 < dist then
          dist = 1
        end
        dist = 1 - dist
        if dist < 0.2 then
          dist = 0.2
        end
        love.graphics.setColor(0, 0, 0, 100)
        local size = self.shadow_size or 25
        love.graphics.ellipse('fill', hit_x, hit_y, size * dist, size * 0.30 * dist)
        return love.graphics.setColor(255, 255, 255)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "CastsShadow",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  CastsShadow = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, first_time, sender)
      if not first_time then
        return 
      end
      __assert_with_msg(self.spine_scale, 'spine_scale')
      __assert_with_msg(self.spine_skeleton_file, 'spine_skeleton_file')
      self.spine_skeleton, self.spine_state = __loadSkeleton(self, self.id, self.spine_skeleton_file, "skeleton", "idle", nil, self.spine_scale, 0, 0)
      __assert_with_msg(self.spine_state, 'spine_state')
      __assert_with_msg(self.spine_skeleton, 'spine_skeleton')
      self.queue = { }
    end,
    step = function(self, dt, sender)
      __assert_with_msg(self.spine_state, 'spine_state')
      __assert_with_msg(self.spine_skeleton, 'spine_skeleton')
      self.spine_state:update(dt * (self.spine_anim_speed or 1))
      self.spine_state:apply(self.spine_skeleton)
      self.spine_skeleton.x = self.x
      self.spine_skeleton.y = self.y + self.spine_h_adjustment
      self.spine_skeleton:updateWorldTransform()
      local b = self.spine_skeleton:findBone('head')
      if b then
        self.head_y = self.y + self.spine_h_adjustment + b.worldY * b.scaleY
      else
        self.head_y = self.y + self.spine_h_adjustment
      end
    end,
    set_anim = function(self, msg, sender)
      if self.curr_anim and (msg.force == nil or msg.force == false) then
        if startswith(self.curr_anim, 'attack') then
          return 
        end
      end
      if self.spine_state == nil then
        return 
      end
      __assert_with_msg(msg, 'sg')
      __assert_with_msg(msg.anim_name, 'sg.anim_name')
      __assert_with_msg(self.spine_state, 'spine_state')
      __assert_with_msg(self.spine_skeleton, 'spine_skeleton')
      __assert_with_msg(self.spine_state.data.skeletonData:findAnimation(msg.anim_name), msg.anim_name)
      self.curr_anim = msg.anim_name
      self.queue = { }
      local looping = false
      if msg.looping then
        looping = true
      end
      return self.spine_state:setAnimationByName(0, msg.anim_name, looping)
    end,
    enqueue_anim = function(self, msg, sender)
      if self.spine_state == nil then
        return 
      end
      __assert_with_msg(self.spine_state.data.skeletonData:findAnimation(msg.anim_name), msg.anim_name)
      if self.curr_anim == nil then
        self.curr_anim = msg.anim_name
        return self.spine_state:setAnimationByName(0, msg.anim_name, false)
      elseif msg.anim_name ~= self.curr_anim then
        return table.insert(self.queue, msg)
      end
    end,
    end_of_anim = function(self, msg, sender)
      if self.curr_anim then
        local anim = table.remove(self.queue)
        if not anim then
          self.curr_anim = nil
          return 
        end
        self.curr_anim = anim.anim_name
        return self.spine_state:setAnimationByName(0, anim.anim_name, false)
      end
    end,
    draw = function(self, msg, sender)
      __assert_with_msg(self.spine_state, 'spine_state')
      __assert_with_msg(self.spine_skeleton, 'spine_skeleton')
      self.spine_skeleton.flipX = self.facing_direction == -1
      return skeletonRenderer:draw(self.spine_skeleton)
    end,
    draw_done = function(self, msg, sender)
      return love.graphics.setColor(255, 255, 255)
    end,
    anim_event = function(self, msg, sender)
      if startswith(msg.event_name, 'sound_') then
        local sound = msg.event_name:match("^sound_(.*)$")
        local file_name = "assets/sound/" .. sound .. ".wav"
        return __play_sound(file_name)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.spine_h_adjustment = 25
      self.head_y = 0
    end,
    __base = _base_0,
    __name = "SpineSkeleton",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SpineSkeleton = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender) end,
    set_room = function(self, room, sender)
      self.idle_anim = 'idle_twohand'
      for key, o in pairs(__monsters) do
        local _continue_0 = false
        repeat
          if o.room ~= room then
            _continue_0 = true
            break
          end
          if o.id == self.id then
            _continue_0 = true
            break
          end
          self.idle_anim = 'idle_3_greatsword'
          self:send(self.id, 'set_anim', {
            anim_name = self.idle_anim
          })
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DetectMonsters",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DetectMonsters = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.score = 0
      self.monsters_killed = 0
    end,
    killed_something = function(self, msg, sender)
      local pts = 50
      self.score = self.score + pts
      __add_to_score_time = __get_time() + 0.3
      if msg.other:is_mixed_in('Baddie') then
        self.monsters_killed = self.monsters_killed + 1
      end
      local b = Text()
      b.scale = 0.8
      self:send(b.id, 'set_pos', {
        msg.other.x,
        msg.other.y - 60
      })
      self:send(b.id, 'set_vel', {
        0,
        -50 - __cosmetic_random() * 10
      })
      return self:send(b.id, 'set_text', "" .. pts)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ScoreHolder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ScoreHolder = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.h = 60
      self.spine_scale = 0.6
      self.spine_skeleton_file = "assets/skeleton/east"
      self:_mixin(Wielder)
      self:_mixin(InputRecorder)
      self:_mixin(CastsShadow)
      self:_mixin(RunSmokey)
      self:_mixin(FacesDirection)
      self:_mixin(SpineSkeleton)
      self:_mixin(Damageable)
      self:_mixin(RoomOccupier)
      self:_mixin(Pickupper)
      self:_mixin(Croucher)
      self:_mixin(Roller)
      self:_mixin(Toucher)
      self:_mixin(GibableWithBones)
      self:_mixin(BBoxed)
      self:_mixin(TouchingGroundChecker)
      self:_mixin(Jumper)
      self:_mixin(Activator)
      self:_mixin(Bleeds)
      self:_mixin(ShowsDmg)
      self:_mixin(Controlled)
      self:_mixin(AnimatedRunner)
      self:_mixin(AnimatedIdler)
      self:_mixin(Levelwarper)
      self:_mixin(GoldHolder)
      self:_mixin(ScoreHolder)
      self:_mixin(Hungers)
      self:_mixin(DetectMonsters)
      self:send(self.id, 'set_anim', {
        anim_name = 'run'
      })
      self.room = current_room
      self.faction = 'good'
      self.hp = 75 + 25.0 / 2
      self.mass = 100
      self.bbox_radius = 22
      self.friction = 100
      self.mass = 7
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Player",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Player = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.scale = 1 - (__get_time() - self.short_lived_start_time) / self.var_short_lived_life_time
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShrinksByShortTimeLeft",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShrinksByShortTimeLeft = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.short_lived_start_time + self.var_short_lived_life_time < __get_time() then
        return self:send(self.id, "remove")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_short_lived_life_time = 0.3
      self.short_lived_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "ShortLived",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShortLived = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if not self.died and self.short_lived_start_time + self.var_short_lived_life_time < __get_time() then
        return self:send(self.id, 'die')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_short_lived_life_time = 0.3
      self.short_lived_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "ShortLivedDies",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShortLivedDies = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    anim_event = function(self, msg, sender)
      if startswith(msg.event_name, 'sound_footstep_big') then
        __screen_shake = __get_time() + 0.100
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Stepsshakescreen",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Stepsshakescreen = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      local klass = _G['Diamond']
      return __throw_object(klass, self, self.facing_direction, {
        0,
        -3000
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "TreasureOnDamage",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  TreasureOnDamage = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self, msg, sender)
      return self.spine_skeleton:setAttachment('hat', self.hat_name)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "HasHat",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  HasHat = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.h = 80
      self.spine_scale = 0.7
      self.spine_skeleton_file = "assets/skeleton/werewolf"
      self.spine_skeleton_slot_name = 'weapon'
      self.spine_skeleton_bbox_name = 'bbox_greatsword'
      self:_mixin(CastsShadow)
      self:_mixin(MovesOnFootstep)
      self:_mixin(AnimatedWalker)
      self:_mixin(AttackWhenCloseToTarget)
      self:_mixin(Baddie)
      self:_mixin(BBoxed)
      self:_mixin(Bleeds)
      self:_mixin(Croucher)
      self:_mixin(Damageable)
      self:_mixin(FacesDirection)
      self:_mixin(GibableWithBones)
      self:_mixin(GoldHolder)
      self:_mixin(PlayerFollower)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(RoomOccupier)
      self:_mixin(SpineSkeleton)
      self:_mixin(SpineAttacker)
      self:_mixin(TouchingGroundChecker)
      self:_mixin(DropsItemsOnDeath)
      self:_mixin(Greatswordwielder)
      self:_mixin(Stepsshakescreen)
      self:_mixin(TreasureOnDamage)
      self.hat_name = 'hat_crown'
      self:_mixin(HasHat)
      self.dropped_object_classes = {
        Goldbar,
        Goldbar
      }
      self.attack_close_to_target_distance = 180
      self.dmg_pts = 50
      self.attack_cooldown_time = 2.5
      self.room = current_room
      self.faction = 'bad'
      self.hp = 500
      self.bbox_radius = 35
      self.friction = 100
      self.mass = 7
      self.walk_speed_max = 250
      self.speed_max = 40
      self.spine_h_adjustment = 35
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Werewolf",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Werewolf = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, msg, sender)
      if self.sprinting then
        if self.sprint_start_time < __get_time() then
          self.walk_speed_max = self.old_walk_speed_max
          self.speed_max = self.old_speed_max
          self.sprinting = false
          self.sprint_start_time = __random() * 4 + 3 + __get_time()
          self:send(self.id, "mixout", "AnimatedRunner")
          self:send(self.id, "mixin", "AnimatedWalker")
          return self.fixture:setFriction(10)
        end
      else
        if self.sprint_start_time < __get_time() then
          self.sprinting = true
          self.old_walk_speed_max = self.walk_speed_max
          self.old_speed_max = self.speed_max
          self.walk_speed_max = 550
          self.speed_max = 500
          self.sprint_start_time = 1 + __get_time()
          self.last_attack = 0
          self:send(self.id, "mixin", "Flashes")
          self:send(self.id, "mixin", "AnimatedRunner")
          self:send(self.id, "mixout", "AnimatedWalker")
          self:send(self.id, 'set_anim', {
            anim_name = 'run'
          })
          return self.fixture:setFriction(1)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sprinting = false
      self.sprint_start_time = __random() * 2 + 1 + __get_time()
    end,
    __base = _base_0,
    __name = "RandomSprinter",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RandomSprinter = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixin = function(self, msg, sender)
      if msg == 'Greatswordwielder' then
        self.dmg_pts = 100
        return self.spine_skeleton:setAttachment('greatsword', 'greatsword')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DumbGreatswordwielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "DumbGreatSwordSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DumbGreatswordwielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = { }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Wielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Wielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.idle_anim = 'idle_mediumsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    start_attack = function(self, msg, sender)
      if self.rolling and self.its_roll_time then
        return self:send(self.id, 'set_anim', {
          anim_name = 'roll_attack_katana'
        })
      elseif self.rolling then
        return 
      elseif self.idle_anim == 'idle_1_katana' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_1_katana'
        })
      elseif self.idle_anim == 'idle_2_katana' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_2_katana'
        })
      elseif self.idle_anim == 'idle_3_katana' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_3_katana'
        })
      end
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_katana' or msg.anim_name == 'attack_3_katana' then
        self.idle_anim = 'idle_2_katana'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_katana' then
        self.idle_anim = 'idle_3_katana'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_onehand'
      self.idle_anim = 'idle_3_katana'
      self.idle_anim = 'idle_1_katana'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "KatanaSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  KatanaSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.idle_anim = 'idle_1_shortsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    start_attack = function(self, msg, sender)
      if self.idle_anim == 'idle_2_shortsword' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_2_shortsword'
        })
      else
        return self:send(self.id, 'set_anim', {
          anim_name = 'attack_1_shortsword'
        })
      end
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_shortsword' then
        self.idle_anim = 'idle_2_shortsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_shortsword' then
        self.idle_anim = 'idle_1_shortsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_3_shortsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShortSwordSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShortSwordSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixin = function(self, msg, sender)
      if msg == 'ShortSwordWithShieldSpineAttacker' then
        self.idle_anim = 'idle_1_shield_shortsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    start_attack = function(self, msg, sender)
      if self.idle_anim == 'idle_2_shield_shortsword' then
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_2_shortsword'
        })
      else
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_1_shortsword'
        })
      end
      return __play_sound("assets/sound/longsword_attack.wav")
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_shortsword' then
        self.idle_anim = 'idle_2_shield_shortsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_shortsword' then
        self.idle_anim = 'idle_1_shield_shortsword'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_3_shortsword'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShortSwordWithShieldSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShortSwordWithShieldSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.idle_anim = 'idle_1_longaxe'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end,
    start_attack = function(self, msg, sender)
      if self.crouching then
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_3_longaxe'
        })
      elseif self.idle_anim == 'idle_2_longaxe' then
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_2_longaxe'
        })
      else
        self:send(self.id, 'set_anim', {
          anim_name = 'attack_1_longaxe'
        })
      end
      return __play_sound("assets/sound/longsword_attack.wav")
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'attack_1_longaxe' then
        self.idle_anim = 'idle_2_longaxe'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_2_longaxe' then
        self.idle_anim = 'idle_1_longaxe'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      elseif msg.anim_name == 'attack_3_longaxe' then
        self.idle_anim = 'idle_3_longaxe'
        return self:send(self.id, 'set_anim', {
          anim_name = self.idle_anim
        })
      end
    end,
    uncrouch = function(self, msg, sender)
      self.idle_anim = 'idle_3_longaxe'
      return self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "LongAxeSpineAttacker",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'SwordSpineAttacker'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  LongAxeSpineAttacker = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self:send(self.id, "mixout", "ShortSwordSpineAttacker")
      self.spine_skeleton_slot_name = 'sword'
      self.spine_skeleton_bbox_name = 'bbox_shortsword'
      self.sword_length_multiplier = 0.5
      self.spine_skeleton:setAttachment('shield_round', 'shield_rock')
      self:send(self.id, 'mixout', 'Busterswordwielder')
      self:send(self.id, 'mixout', 'Greatswordwielder')
      self:send(self.id, 'mixout', 'Katanawielder')
      return self:send(self.id, 'mixout', 'Longaxewielder')
    end,
    mixed_out = function(self, msg, sender)
      return self.spine_skeleton:setAttachment('shield_round', nil)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Shieldwielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "ShortSwordWithShieldSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Shieldwielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.attack_cooldown_time = 0
      self.dmg_pts = 100
      self.sword_length_multiplier = 2.5
      self.spine_skeleton_slot_name = 'sword'
      self.spine_skeleton_bbox_name = 'bbox_shortsword'
      self.spine_skeleton:setAttachment('shortsword', 'tantou')
      self:send(self.id, 'set_anim', {
        anim_name = 'idle_1_shortsword',
        force = true
      })
      self.its_hit_time = false
      self:send(self.id, 'mixout', 'Busterswordwielder')
      self:send(self.id, 'mixout', 'Greatswordwielder')
      self:send(self.id, 'mixout', 'Katanawielder')
      return self:send(self.id, 'mixout', 'Longaxewielder')
    end,
    mixed_out = function(self, msg, sender)
      self.spine_skeleton:setAttachment('shortsword', nil)
      return self:send(self.id, 'drop_ball', {
        name = 'Shortsword'
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Shortswordwielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "ShortSwordSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Shortswordwielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.gashapon_ball_class_name = 'Katana'
      self.dmg_pts = 100
      self.spine_skeleton_slot_name = 'samurai_sword'
      self.spine_skeleton_bbox_name = 'bbox_katana'
      self.sword_length_multiplier = 0.5
      self.spine_skeleton:setAttachment('katana', 'ninjatou')
      self.idle_anim = 'idle_1_katana'
      self:send(self.id, 'set_anim', {
        anim_name = 'idle_1_katana',
        force = true
      })
      self.its_hit_time = false
      self:send(self.id, 'mixout', 'Shortswordwielder')
      self:send(self.id, 'mixout', 'Shieldwielder')
      self:send(self.id, 'mixout', 'Longaxewielder')
      self:send(self.id, 'mixout', 'Busterswordwielder')
      return self:send(self.id, 'mixout', 'Greatswordwielder')
    end,
    mixed_out = function(self, msg, sender)
      self.spine_skeleton:setAttachment('katana', nil)
      return self:send(self.id, 'drop_ball', {
        name = 'Katana'
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Katanawielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "KatanaSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Katanawielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.gashapon_ball_class_name = 'Longaxe'
      self.dmg_pts = 100
      self.sword_length_multiplier = 0.5
      self.spine_skeleton_slot_name = 'axe'
      self.spine_skeleton_bbox_name = 'bbox_longaxe'
      self.spine_skeleton:setAttachment('longaxe', 'vikingaxe')
      self:send(self.id, 'set_anim', {
        anim_name = 'idle_1_longaxe',
        force = true
      })
      self.its_hit_time = false
      self:send(self.id, 'mixout', 'Busterswordwielder')
      self:send(self.id, 'mixout', 'Greatswordwielder')
      self:send(self.id, 'mixout', 'Katanawielder')
      self:send(self.id, 'mixout', 'Shieldwielder')
      return self:send(self.id, 'mixout', 'Shortswordwielder')
    end,
    mixed_out = function(self, msg, sender)
      self.spine_skeleton:setAttachment('longaxe', nil)
      return self:send(self.id, 'drop_ball', {
        name = 'Longaxe'
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Longaxewielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "LongAxeSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Longaxewielder = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.h = 80
      self.spine_scale = 0.35
      self.spine_skeleton_file = "assets/skeleton/skelly"
      self.spine_skeleton_slot_name = 'weapon'
      self.spine_skeleton_bbox_name = 'bbox_greatsword'
      self:_mixin(CastsShadow)
      self:_mixin(RunSmokey)
      self:_mixin(AnimatedWalker)
      self:_mixin(AttackWhenCloseToTarget)
      self:_mixin(Baddie)
      self:_mixin(BBoxed)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(Croucher)
      self:_mixin(Damageable)
      self:_mixin(DropsItemsOnDeath)
      self:_mixin(FacesDirection)
      self:_mixin(GibableWithBones)
      self:_mixin(GoldHolder)
      self:_mixin(DumbGreatswordwielder)
      self:_mixin(PlayerFollower)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(RoomOccupier)
      self:_mixin(SpineAttacker)
      self:_mixin(SpineSkeleton)
      self:_mixin(TouchingGroundChecker)
      self:_mixin(RandomSprinter)
      self.dropped_object_classes = {
        Goldbar
      }
      self.attack_close_to_target_distance = 120
      self.dmg_pts = 100
      self.attack_cooldown_time = 10
      self.room = current_room
      self.faction = 'bad'
      self.hp = 200
      self.bbox_radius = 24
      self.friction = 10
      self.mass = 1000
      self.walk_speed_max = 100
      self.speed_max = 10
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Reanimated",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Reanimated = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.contactable_in_time_start_time + self.var_contactable_in_time_life_time < __get_time() then
        self:send(self.id, "mixin", "Contactable")
        return self:send(self.id, "mixout", "ContactableInTime")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_contactable_in_time_life_time = 1
      self.contactable_in_time_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "ContactableInTime",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ContactableInTime = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      return self:send(self.id, "mixout", "Damageable")
    end,
    step = function(self, dt, sender)
      if self.damageable_in_time_start_time + self.var_damageable_in_time_life_time < __get_time() then
        self:send(self.id, "mixin", "Damageable")
        return self:send(self.id, "mixout", "DamageableInTime")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_damageable_in_time_life_time = 1
      self.damageable_in_time_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "DamageableInTime",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DamageableInTime = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      local scale = 1
      if self.short_lived_start_time then
        scale = 1 - (__get_time() - self.short_lived_start_time) / self.var_short_lived_life_time
      end
      self.blood:update(dt)
      self.blood:setSizes(0, scale * 2)
      return self.blood:setParticleLifetime(0.1, scale)
    end,
    draw = function(self, msg, sender)
      return love.graphics.draw(self.blood, self.x, self.y)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      if not self.bloodimg then
        self.bloodimg = __load_image("assets/gfx/blood_puffy.png")
      end
      self.blood = love.graphics.newParticleSystem(self.bloodimg, 100)
      self.blood:setParticleLifetime(0.1, 1)
      self.blood:setEmissionRate(20)
      self.blood:setSizeVariation(1)
      self.blood:setSizes(1, 2)
      self.blood:setLinearAcceleration(-100, 600, 100, 600)
      self.blood:setRotation(-4, 4)
      return self.blood:setColors(255, 255, 255, 255, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "Bloody",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bloody = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.ps:update(dt)
      self.ps:setPosition(self.x, self.y + 20)
      if self.touching_ground and 400 < math.abs(self.x_vel) then
        return self.ps:emit((math.abs(self.x_vel) - 400) / 100)
      end
    end,
    draw = function(self, msg, sender)
      return love.graphics.draw(self.ps)
    end,
    touch_ground = function(self, msg, sender)
      return self.ps:emit(10)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/smoke_breathable.png")
      self.ps = love.graphics.newParticleSystem(img, 100)
      self.ps:setParticleLifetime(1, 1)
      self.ps:setSizes(0.5, 0.25, 0.12, 0.06)
      self.ps:setLinearAcceleration(-50, -50, 50, -50)
      self.ps:setRotation(-20, 20)
      self.ps:setSpin(-20, 20)
      return self.ps:setColors(255, 255, 255, 255, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "RunSmokey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RunSmokey = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.ps_smoke:update(dt)
      return self.ps_smoke:setPosition(self.x, self.y)
    end,
    draw = function(self, msg, sender)
      self.ps_smoke:setSizes(self.scale * 0.5)
      self.ps_smoke:emit(1)
      return love.graphics.draw(self.ps_smoke)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/smoke_breathable.png")
      self.ps_smoke = love.graphics.newParticleSystem(img, 100)
      self.ps_smoke:setAreaSpread('normal', 10, 10)
      self.ps_smoke:setParticleLifetime(1, 0.5)
      self.ps_smoke:setSizes(0.5)
      self.ps_smoke:setLinearAcceleration(-50, -50, 50, -50)
      self.ps_smoke:setRotation(-20, 20)
      self.ps_smoke:setSpin(-20, 20)
      return self.ps_smoke:setColors(255, 255, 255, 255, 100, 100, 100, 0)
    end,
    __base = _base_0,
    __name = "Smokey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'ForegroundDrawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Smokey = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.ps_smoke:update(dt)
      self.ps_smoke:setPosition(self.x, self.y)
      if 50 < math.abs(self.x_vel) then
        return self.ps_smoke:emit(1)
      end
    end,
    draw = function(self, msg, sender)
      self.ps_smoke:setSizes(self.scale * 0.1)
      return love.graphics.draw(self.ps_smoke)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/smoke_breathable.png")
      self.ps_smoke = love.graphics.newParticleSystem(img, 100)
      self.ps_smoke:setParticleLifetime(0.5, 0.7)
      self.ps_smoke:setSizes(0.5)
      self.ps_smoke:setLinearAcceleration(0, -100, 0, -100)
      self.ps_smoke:setRotation(-20, 20)
      self.ps_smoke:setSpin(-20, 20)
      return self.ps_smoke:setColors(255, 255, 255, 255, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "DartTrail",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DartTrail = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    touch = function(self, msg, sender)
      return self.body:applyLinearImpulse(0, -5)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Ladderable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Ladderable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self, msg, sender)
      return self.body:setAngle(90)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "RotatedRight",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  RotatedRight = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self:_mixin(Smokey)
      return self:_mixin(Stepper)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Smoke",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Smoke = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/debris.png")
      self:_mixin(RoomOccupier)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self:_mixin(SpriteAnimated)
      self:_mixin(Stepper)
      self:_mixin(BBoxed)
      self:_mixin(AngledSprite)
      self.w = 32
      self.h = 32
      self.bbox_radius = 1
      self.scale = 1
      self.anims["flame"] = __load_anim("assets/gfx/flame.png", 32, 32, .05, 1, 0)
      self.anims["flame"]:setMode('loop')
      self:send(self.id, 'set_anim', {
        anim_name = 'flame'
      })
      self.var_short_lived_life_time = 2
      self.mass = 0.1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Fire",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Fire = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self:_mixin(Sprite)
      self:_mixin(Stepper)
      self.h = 32
      self.scale = 1 + __cosmetic_random() * 1
      self.sprite = __load_image("assets/gfx/poison_bubble.png")
      self.var_short_lived_life_time = 2
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Poisonbubble",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Poisonbubble = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/explode.png")
      self.scale = 5
      self:_mixin(Sprite)
      self:_mixin(Smokey)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ExplosionDebris",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ExplosionDebris = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Touchable)
      return self:_mixin(Ladderable)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Ladder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Ladder = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Bloody)
      self:_mixin(Stepper)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1.7
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Blood",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Blood = _class_0
end
do
  local _parent_0 = Blood
  local _base_0 = {
    mixins = function(self)
      self.bloodimg = __load_image("assets/gfx/bug_blood.png")
      _parent_0.mixins(self)
      self.var_short_lived_life_time = 1.3
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "BugBlood",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BugBlood = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmging = function(self, msg, sender)
      msg.piercing = true
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Piercingattack",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Piercingattack = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/kunai.png")
      self:_mixin(Piercingattack)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(DamageOnContact)
      self:_mixin(RemovedOnDamage)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1
      self:_mixin(RotatedRight)
      self.dmg_pts = 50
      self.speed_max = 3000
      self.faction = 'kunai'
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ThrowingKunai",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ThrowingKunai = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/zdart.png")
      self:_mixin(Piercingattack)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Contactable)
      self:_mixin(Pickupable)
      self:_mixin(SleepOnContact)
      self:_mixin(DartTrail)
      self.var_short_lived_life_time = 1
      self:_mixin(RotatedRight)
      self.dmg_pts = 0
      self.speed_max = 10000
      self.faction = 'zdart'
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ZDart",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ZDart = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/landmine.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Contactable)
      self:_mixin(DiesOnContact)
      self:_mixin(Damageable)
      self:_mixin(RemovedOnDamage)
      self:_mixin(Explodesondeath)
      self.attack_range = 50
      self.dmg_pts = 150
      self.speed_max = 3000
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Landmine",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Landmine = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/cinderblock.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(RemovedOnDamage)
      self.dmg_pts = 10
      self.speed_max = 3000
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "CinderBlock",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  CinderBlock = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/health_potion.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      return self:_mixin(BBoxSprite)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Healthpotion",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Healthpotion = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxed)
      self:_mixin(AngledSprite)
      self.mass = 0.4
      self.friction = 100
      self.restitution = 0.1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Gib",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Gib = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self:_mixin(CastsShadow)
      self.shadow_size = 10
      self.sprite = __load_image("assets/gfx/skull.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Skull",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Skull = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/eye.png")
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 4
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "EyeGib",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  EyeGib = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      if __cosmetic_random() < 0.5 then
        self.sprite = __load_image("assets/gfx/melon_gib.png")
      else
        self.sprite = __load_image("assets/gfx/melon_gib2.png")
      end
      _parent_0.mixins(self)
      self:_mixin(ContactableInTime)
      self:_mixin(Pickupable)
      self:_mixin(GivesHP)
      self:_mixin(GivesFood)
      self.scale = 1.3
      self.food_value = 1
      self.hp_pts = 1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Watermelongib",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Watermelongib = _class_0
end
do
  local _parent_0 = Blood
  local _base_0 = {
    mixins = function(self)
      self.bloodimg = __load_image("assets/gfx/melon_spurt.png")
      _parent_0.mixins(self)
      self.var_short_lived_life_time = 1.7
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Watermelonspurt",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Watermelonspurt = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Watermelon.init)
      self:add_handler('die', Watermelon.die)
      self:_mixin(Damageable)
      self.sprite = __load_image("assets/gfx/melon.png")
      return _parent_0.mixins(self)
    end,
    init = function(self, msg, sender)
      self.restitution = 0.1
    end,
    die = function(self, msg, sender)
      local magnitude = 200
      __play_sound("assets/sound/gib.wav")
      for i = 1, 5 do
        local o = Watermelongib()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y - 60
        })
        self:send(o.id, 'set_vel', random_direction(magnitude))
      end
      local o = Watermelonspurt()
      return self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Watermelon",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Watermelon = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/heart.png")
      _parent_0.mixins(self)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Heart",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Heart = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/giblet.png")
      _parent_0.mixins(self)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self:_mixin(Bloody)
      self.var_short_lived_life_time = 2
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Giblet",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Giblet = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/bug_giblet.png")
      _parent_0.mixins(self)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 0.5
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "BugGiblet",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BugGiblet = _class_0
end
do
  local _parent_0 = Gib
  local _base_0 = {
    mixins = function(self)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.sprite = __load_image("assets/gfx/ribcage.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Ribcage",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Ribcage = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      return __play_sound("assets/sound/hurt.wav")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PlaysSoundWhenDead",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PlaysSoundWhenDead = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(CastsShadow)
      self.shadow_size = 16
      self:_mixin(DamageableInTime)
      self:_mixin(PlaysSoundWhenDead)
      self:_mixin(PuffsWhenDead)
      self.sprite = __load_image("assets/gfx/limb.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self.mass = 0.4
      self.friction = 100
      self.restitution = 0.1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Limb",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Limb = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    pre_dmg = function(self, msg, sender)
      if msg.piercing then
        return self:send(self.id, 'dmg', {
          pts = msg.pts * 10
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Piercingvunerable",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Piercingvunerable = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      return __play_sound("assets/sound/eye_die.wav")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ScreamsOnDeath",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ScreamsOnDeath = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Eye.init)
      self:_mixin(Baddie)
      self:_mixin(CastsShadow)
      self:_mixin(Piercingvunerable)
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(Controlled)
      self:_mixin(PlayerFollower)
      self:_mixin(Sprite)
      self:_mixin(BBoxed)
      self:_mixin(Gibable)
      self:_mixin(Bleeds)
      self:_mixin(Hovers)
      self:_mixin(Screamer)
      self:_mixin(ScreamsOnDeath)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(DamageOnContact)
      self.dmg_pts = 20
      self.scream_sound_file = "assets/sound/eye_scream.wav"
      self.sprite = __load_image("assets/gfx/eye_ball.png")
      self.sprite2 = __load_image("assets/gfx/pupil.png")
      self:add_handler("draw", Eye.draw)
      self.attack_cooldown_time = 1.5
      self.var_damage_on_contact_time = 1
      self.faction = 'bad'
      self.bbox_radius = 30
    end,
    init = function(self, msg, sender)
      self.bbox_radius = 30
    end,
    draw = function(self, msg, sender)
      local y = math.cos(__get_time() * 10) * 5
      local x = math.sin(__get_time() * 10) * 10
      return love.graphics.draw(self.sprite2, x + self.x, y + self.y, 0, 1, 1, self.sprite2:getWidth() / 2, self.sprite2:getHeight() / 2)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Eye",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Eye = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.w = 32
      self.h = 32
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(RectangleBBox)
      self:_mixin(QuadSprite)
      self:_mixin(LightingDrawable)
      self:_mixin(Dissolves)
      self:_mixin(DropsItemsOnDeath)
      self.sprite = self.room.map.tilesets[1].image
      self.quad = love.graphics.newQuad(2 * 32, 2 * 32, 32, 32, self.sprite:getWidth(), self.sprite:getHeight())
      self.dropped_object_classes = {
        Turkey
      }
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Secretwall",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Secretwall = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    contact = function(self, msg, sender)
      return self.body:applyLinearImpulse(0, -100 - __random() * 500)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PerpetualBounce",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PerpetualBounce = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BBoxed)
      self:_mixin(Contactable)
      self:_mixin(Controlled)
      self:_mixin(Damageable)
      self:_mixin(PerpetualBounce)
      self:_mixin(RoomOccupier)
      self:_mixin(Sprite)
      self.bbox_radius = 16
      self.dmg_pts = 20
      self.faction = 'bad'
      self.hp = 1000
      self.restitution = 1
      self.sprite = __load_image("assets/gfx/steel_ball.png")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Steelball",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Steelball = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      if sender == player.id then
        __world_pause = __get_time() + 0.0800
        __screen_shake = __get_time() + 0.100
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PlayersHitSlowsTime",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PlayersHitSlowsTime = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      if sender == player.id then
        __screen_shake = __get_time() + 0.100
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "PlayersHitShakesScreen",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PlayersHitShakesScreen = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.target and math.abs(self.target.x - self.x) < self.attack_close_to_target_distance then
        return self:send(self.id, 'cmd_primary_pressed')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.attack_close_to_target_distance = 100
    end,
    __base = _base_0,
    __name = "AttackWhenCloseToTarget",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AttackWhenCloseToTarget = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.w = 80
      self.h = 140
      self:_mixin(Baddie)
      self:_mixin(AnimatedWalker)
      self:_mixin(Attacker)
      self:_mixin(Bleeds)
      self:_mixin(CastsShadow)
      self:_mixin(Controlled)
      self:_mixin(Damageable)
      self:_mixin(FacesDirectionByVelocity)
      self:_mixin(GibableWithBones)
      self:_mixin(PlayerFollower)
      self:_mixin(RoomOccupier)
      self:_mixin(SpriteAnimated)
      self:_mixin(Toucher)
      self:_mixin(Walker)
      self:_mixin(SimpleAttacker)
      self:_mixin(GoldHolder)
      self:_mixin(FlamePuncher)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(AttackWhenCloseToTarget)
      self:_mixin(DropsItemsOnDeath)
      self.dropped_object_classes = {
        Goldbar
      }
      self.droprate = 0.4
      self.anims['run'] = __load_anim("assets/gfx/reverant_walking.png", 80, 103, .175, 1, 0)
      self.anims['run']:setMode('once')
      self.anims['walk'] = __load_anim("assets/gfx/reverant_walking.png", 80, 103, .175, 1, 0)
      self.anims['walk']:setMode('once')
      self.anims["idle"] = __load_anim("assets/gfx/reverant_standing.png", 80, 103, .15, 1, 1)
      self.anims["idle"]:setMode('once')
      self.anims["attack"] = __load_anim("assets/gfx/reverant_attacking.png", 80, 103, .15, 1, 1)
      self.anims["attack"]:setMode('once')
      self.walk_speed_max = 200
      self.speed_max = 40
      self:send(self.id, 'set_anim', {
        anim_name = 'run'
      })
      self.attack_cooldown_time = 0.7
      self.faction = 'bad'
      self.dmg_pts = 30
      self.hp = 150
      self.bbox_radius = 25
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Monster",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Monster = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:add_handler("init_full", Randommonster.init_full)
    end,
    init_full = function(self, msg, sender)
      local monsters = {
        Werewolf,
        Eye,
        Monster,
        Reanimated,
        Imp
      }
      local idx = math.floor(__random() * 10) % #monsters + 1
      local cls = monsters[idx]
      local o = cls()
      self:send(o.id, 'set_pos', {
        self.x + math.abs(__random()) * self.world_obj.width,
        self.y
      })
      self:send(o.id, 'set_room', self.room)
      poll_messages()
      self:send(o.id, 'init_full')
      if self.world_obj and self.world_obj.properties.child_mixins then
        return self:send(o.id, 'mixin', self.world_obj.properties.child_mixins)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Randommonster",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Randommonster = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:add_handler("init_full", Randomsetpieces.init_full)
    end,
    init_full = function(self, msg, sender)
      local objects = {
        'Barrel',
        'Barrel',
        'Barrel',
        'Watermelon',
        'Explodingbarrel',
        'Gashapon'
      }
      local count = 1
      if self.world_obj.properties.count then
        count = tonumber(self.world_obj.properties.count)
      end
      for i = 1, count + 1 do
        local cls = nil
        if self.world_obj.properties.object ~= nil then
          cls = __get_class_from_string(self.world_obj.properties.object)
        else
          local idx = math.floor(__random() * 10) % #objects + 1
          cls = __get_class_from_string(objects[idx])
        end
        local o = cls()
        self:send(o.id, 'set_pos', {
          self.x + math.abs(__random()) * self.world_obj.width,
          self.y
        })
        self:send(o.id, 'set_room', self.room)
        if self.world_obj.properties.child_mixins then
          self:send(o.id, 'mixin', self.world_obj.properties.child_mixins)
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Randomsetpieces",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Randomsetpieces = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.blood_class = BugBlood
      self.sprite = __load_image("assets/gfx/roach.png")
      self:_mixin(Baddie)
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(PlayerFollower)
      self:_mixin(BBoxed)
      self:_mixin(BBoxSprite)
      self:_mixin(GibableBug)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(DamageOnContact)
      self:_mixin(Hovers)
      self:_mixin(Contactable)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(Screamer)
      self.scream_sound_file = "assets/sound/bug_scream.wav"
      self.scream_time = 1
      self.var_damage_on_contact_time = 0.5
      self.dmg_pts = 5
      self.hp = 20
      self.speed_max = 100
      self.attack_cooldown_time = 1.5
      self.faction = 'bad'
      self.hover_height = 350
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Roach2",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Roach2 = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.blood_class = BugBlood
      self.spine_scale = 0.6
      self.spine_skeleton_file = "assets/skeleton/roach"
      self:_mixin(CastsShadow)
      self:_mixin(Baddie)
      self:_mixin(AnimatedFlier)
      self:_mixin(SpineSkeleton)
      self:_mixin(Baddie)
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(PlayerFollower)
      self:_mixin(BBoxed)
      self:_mixin(GibableBug)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(DamageOnContact)
      self:_mixin(RandomJumper)
      self:_mixin(Contactable)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(FacesDirection)
      self:_mixin(Screamer)
      self:_mixin(AnimatedWalker)
      self.scream_sound_file = "assets/sound/bug_scream.wav"
      self.scream_time = 1
      self.var_damage_on_contact_time = 0.5
      self.dmg_pts = 5
      self.hp = 20
      self.speed_max = 100
      self.attack_cooldown_time = 1.5
      self.faction = 'bad'
      self.hover_height = 350
      self.bbox_radius = 16
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Roach",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Roach = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.blood_class = BugBlood
      self.spine_scale = 0.9
      self.spine_skeleton_file = "assets/skeleton/roach"
      self:_mixin(CastsShadow)
      self:_mixin(Baddie)
      self:_mixin(AnimatedFlier)
      self:_mixin(SpineSkeleton)
      self:_mixin(Baddie)
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(PlayerFollower)
      self:_mixin(BBoxed)
      self:_mixin(GibableBug)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(DamageOnContact)
      self:_mixin(Contactable)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(FacesDirection)
      self:_mixin(Screamer)
      self:_mixin(AnimatedWalker)
      self:_mixin(DamageReplacesObject)
      self.replacement_classes = {
        Roach,
        Roach,
        Roach
      }
      self.scream_sound_file = "assets/sound/bug_scream.wav"
      self.scream_time = 1
      self.var_damage_on_contact_time = 0.5
      self.dmg_pts = 5
      self.hp = 40
      self.speed_max = 100
      self.attack_cooldown_time = 1.5
      self.faction = 'bad'
      self.hover_height = 350
      self.bbox_radius = 26
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Paparoach",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Paparoach = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.blood_class = BugBlood
      self.spine_scale = 0.7
      self.spine_skeleton_file = "assets/skeleton/barrelmonster"
      self:_mixin(Baddie)
      self:_mixin(SpineSkeleton)
      self:_mixin(Baddie)
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(PlayerFollower)
      self:_mixin(BBoxed)
      self:_mixin(GibableBug)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(DamageOnContact)
      self:_mixin(Contactable)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(FacesDirection)
      self:_mixin(AnimatedWalker)
      self.var_damage_on_contact_time = 0.5
      self.spine_h_adjustment = 18
      self.dmg_pts = 5
      self.hp = 20
      self.speed_max = 20
      self.attack_cooldown_time = 1.5
      self.faction = 'bad'
      self.hover_height = 350
      self.bbox_radius = 16
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Barrelmonster",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Barrelmonster = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, dt, sender)
      if not self.ceiling_attachment then
        return 
      end
      love.graphics.setColor(100, 100, 100)
      local segments = 12
      self.body:setFixedRotation(true)
      local pos1 = vector.new(self.ceiling_attachment.x, self.ceiling_attachment.y)
      local pos2 = vector.new(self.x, self.y - 8)
      local last_x = self.ceiling_attachment.x
      local last_y = self.ceiling_attachment.y
      local sub = vector.new(0, 1)
      local ratio = 0
      for i = 0, segments + 1 do
        pos1 = vector.new(last_x, last_y)
        local sub2 = pos2 - pos1
        local segment_length = pos1:dist(pos2) / (segments - i)
        sub2:normalize_inplace()
        ratio = i / segments
        sub2.x = sub2.x * ratio + sub.x * (1 - ratio)
        sub2.y = sub2.y * ratio + sub.y * (1 - ratio)
        local x = last_x + sub2.x * segment_length
        local y = last_y + sub2.y * segment_length
        love.graphics.line(last_x, last_y, x, y)
        last_x = x
        last_y = y
      end
      return love.graphics.setColor(255, 255, 255)
    end,
    set_pos = function(self, msg, sender)
      if self.ceiling_attachment then
        return self:send(self.ceiling_attachment.id, 'set_pos', msg)
      else
        return self:send(self.id, 'make_ceiling_attachment')
      end
    end,
    make_ceiling_attachment = function(self, msg, sender)
      if self.ceiling_attachment then
        return 
      end
      local target_pos = {
        self.x,
        0
      }
      local hit_x, hit_y = __find_closest_point(self.room, {
        self.x,
        self.y
      }, target_pos)
      if hit_y then
        self.y_attachment = hit_y
        local o = Ceilingattachment()
        self.ceiling_attachment = o
        local pos = {
          self.x,
          self.y_attachment
        }
        self:send(o.id, 'set_pos', pos)
        local length = distance(pos[1], pos[2], self.x, self.y)
        if self.attachment_length then
          length = self.attachment_length
        end
        return self:send(o.id, 'attach', {
          x = self.x,
          y = self.y,
          length = length,
          body = self.body
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Attachestoceiling",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Attachestoceiling = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      self.next_spit = 0
    end,
    step = function(self, dt, sender)
      if self.curr_anim == nil then
        return self:send(self.id, 'set_anim', {
          anim_name = 'grow'
        })
      end
    end,
    anim_event = function(self, msg, sender)
      if msg.event_name == 'hatch' then
        local o = Roach()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y + 40
        })
        self:send(o.id, 'set_vel', {
          0,
          100
        })
        local b = BugBlood()
        return self:send(b.id, 'set_pos', {
          self.x,
          self.y
        })
      end
    end,
    end_of_anim = function(self, msg, sender)
      if msg.anim_name == 'grow' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'hatch',
          force = true
        })
      elseif msg.anim_name == 'hatch' then
        return self:send(self.id, 'set_anim', {
          anim_name = 'grow',
          force = true
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SpitsOutBugs",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SpitsOutBugs = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.blood_class = BugBlood
      self.sprite = __load_image("assets/gfx/roach.png")
      self.spine_scale = 0.6
      self.spine_skeleton_file = "assets/skeleton/egg"
      self:_mixin(Baddie)
      self.attachment_length = 2
      self:_mixin(RoomOccupier)
      self:_mixin(Damageable)
      self:_mixin(BBoxed)
      self:_mixin(GibableBug)
      self:_mixin(Bleeds)
      self:_mixin(Controlled)
      self:_mixin(Stepper)
      self:_mixin(PlayersHitSlowsTime)
      self:_mixin(SpitsOutBugs)
      self:_mixin(Attachestoceiling)
      self:_mixin(SpineSkeleton)
      self.spine_h_adjustment = 0
      self.faction = 'bad'
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Roachnest",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Roachnest = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:add_handler("init_full", Monsters.init_full)
    end,
    init_full = function(self, msg, sender)
      local monsters = {
        Roachnest,
        Roachnest,
        Eye,
        Monster,
        Monster,
        Monster,
        Reanimated,
        Imp,
        Imp,
        Imp,
        Barrelmonster,
        Werewolf
      }
      for i = 1, 1 + math.floor(math.abs(__random() * 3)) do
        local cls = monsters[math.floor(__random() * 10) % #monsters + 1]
        local o = cls()
        self:send(o.id, 'set_pos', {
          self.x + __random() * 100,
          self.y - 100
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Monsters",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Monsters = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      return __play_sound("assets/sound/pickup_powerup.wav")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Powerup",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Powerup = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      self:send(msg.activator_id, 'set_anim', {
        anim_name = 'drink',
        force = true
      })
      return __play_sound("assets/sound/drink_powerup.wav")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Drink",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Drink = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(ContactableInTime)
      self:_mixin(RoomOccupier)
      self:_mixin(Pickupable)
      return self:_mixin(BBoxSprite)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Item",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Item = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      return self:send(msg.activator_id, 'set_fields', self.activate_injections)
    end,
    add_injected_fields = function(self, msg, sender)
      if self.activate_injections == nil then
        self.activate_injections = { }
      end
      for field, value in pairs(msg) do
        self.activate_injections[field] = value
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "InjectFieldsWhenActivated",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  InjectFieldsWhenActivated = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self:_mixin(MixinWhenActivated)
      self:_mixin(InjectFieldsWhenActivated)
      self:_mixin(Powerup)
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ItemGrantsMixin",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ItemGrantsMixin = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self:_mixin(MixinWhenActivated)
      self:_mixin(InjectFieldsWhenActivated)
      self:_mixin(Drink)
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DrinkGrantsMixin",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DrinkGrantsMixin = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.throw_payload = 15
      self.sprite = __load_image("assets/gfx/kunaibox.png")
      self.activate_mixins = {
        "KunaiThrower",
        'Flashes'
      }
      self.activate_injections = {
        throw_payload = self.throw_payload
      }
      self.pickup_message = {
        "You got",
        "throwing kunais!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Kunaibox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Kunaibox = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.throw_payload = 10 or self.throw_payload
      self.sprite = __load_image("assets/gfx/zpipebox.png")
      self.activate_mixins = {
        "DartBlower",
        'Flashes'
      }
      self.activate_injections = {
        throw_payload = self.throw_payload
      }
      self.pickup_message = {
        "You got",
        "tranquilizer",
        "blow pipe!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Zpipebox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Zpipebox = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, msg, sender)
      if self.caffeinated_time < __get_time() and self.caffeinated_time ~= 0 then
        return self:send(self.id, "mixout", 'Caffeinated')
      end
    end,
    mixed_in = function(self, first_time, sender)
      if (self.caffeinated_time or 0) < __get_time() then
        self.speed_max = self.speed_max * 1.5
        self.spine_anim_speed = self.spine_anim_speed * 1.5
      end
      self.caffeinated_time = __get_time() + 15
    end,
    mixed_out = function(self, msg, sender)
      self.speed_max = self.speed_max / 1.5
      self.spine_anim_speed = self.spine_anim_speed / 1.5
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Caffeinated",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Caffeinated = _class_0
end
do
  local _parent_0 = DrinkGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self:_mixin(CastsShadow)
      self.shadow_size = 8
      self.sprite = __load_image("assets/gfx/can.png")
      self.activate_mixins = {
        "Caffeinated",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "coffee!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Coffee",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Coffee = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, first_time, sender)
      self.dmg_pts = 100
      self.sword_length_multiplier = 1.4
      self.spine_skeleton_slot_name = 'sword'
      self.spine_skeleton_bbox_name = 'bbox_greatsword'
      self.spine_skeleton:setAttachment('greatsword', 'greatsword')
      self.idle_anim = 'idle_1_greatsword'
      self:send(self.id, 'set_anim', {
        anim_name = self.idle_anim,
        force = true
      })
      self.its_hit_time = false
      self:send(self.id, 'mixout', 'Busterswordwielder')
      self:send(self.id, 'mixout', 'Katanawielder')
      self:send(self.id, 'mixout', 'Longaxewielder')
      self:send(self.id, 'mixout', 'Shieldwielder')
      return self:send(self.id, 'mixout', 'Shortswordwielder')
    end,
    mixed_out = function(self, msg, sender)
      self.spine_skeleton:unsetAttachment('greatsword', 'greatsword')
      return self:send(self.id, 'drop_ball', {
        name = 'Greatsword'
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Greatswordwielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "GreatSwordSpineAttacker",
    'AttackerP',
    'FacesDirection',
    'SwordSwoosher',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Greatswordwielder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    drop_ball = function(self, msg, sender)
      local o = GashaponBall()
      o.dropped_object_classes = {
        __get_class_from_string(msg.name)
      }
      self:send(o.id, 'add_injected_fields', msg)
      self:send(o.id, 'mixout', 'ShortLivedDies')
      return self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SpitsGashaponBallOut",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SpitsGashaponBallOut = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      self.dmg_pts = 100
      self.sword_length_multiplier = 1.4
      self.spine_skeleton_slot_name = 'sword'
      self.spine_skeleton_bbox_name = 'bbox_greatsword'
      self.spine_skeleton:setAttachment('greatsword', 'buster1sword')
      self:send(self.id, 'set_anim', {
        anim_name = 'idle_1_greatsword',
        force = true
      })
      self.its_hit_time = false
      self:send(self.id, 'mixout', 'Greatswordwielder')
      self:send(self.id, 'mixout', 'Katanawielder')
      self:send(self.id, 'mixout', 'Longaxewielder')
      self:send(self.id, 'mixout', 'Shieldwielder')
      return self:send(self.id, 'mixout', 'Shortswordwielder')
    end,
    mixed_out = function(self, msg, sender)
      self.spine_skeleton:unsetAttachment('greatsword', 'buster1sword')
      return self:send(self.id, 'drop_ball', {
        name = 'Bustersword'
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Busterswordwielder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    "SuperGreatSwordSpineAttacker",
    'AttackerP2',
    'FacesDirection',
    'SwordSwoosher',
    'SpitsGashaponBallOut'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Busterswordwielder = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.pickup_class_name = 'Wielder'
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "WeaponItem",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  WeaponItem = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/greatsword.png")
      self.activate_mixins = {
        "Greatswordwielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the great sword!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Greatsword",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Greatsword = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/tantou.png")
      self.activate_mixins = {
        "Shortswordwielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the tantou!"
      }
      self.scale = 0.5
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Shortsword",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Shortsword = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/ninjatou_sheathed.png")
      self.activate_mixins = {
        "Katanawielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the katana!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Katana",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Katana = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/vikingaxe.png")
      self.activate_mixins = {
        "Longaxewielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the Ono!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Longaxe",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Longaxe = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/shield_rock.png")
      self.activate_mixins = {
        "Shieldwielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the broad sword!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Shield",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Shield = _class_0
end
do
  local _parent_0 = WeaponItem
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/skeleton/east/buster1sword.png")
      self.activate_mixins = {
        "Busterswordwielder",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "the buster sword!",
        "",
        "Hold down attack",
        "for power slash"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Bustersword",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bustersword = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.throw_payload = 15
      self.activate_injections = {
        throw_payload = self.throw_payload
      }
      self.sprite = __load_image("assets/gfx/tntbox.png")
      self.activate_mixins = {
        "LandmineLayer",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "land mines!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Tntbox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Tntbox = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      for _, mixin in pairs(self.activate_mixins) do
        self:send(msg.activator_id, "mixin_if_not_mixed_in", mixin)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "MixinWhenActivated",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MixinWhenActivated = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      self.gold = 0
    end,
    give_gold = function(self, gold_value, sender)
      self.gold = self.gold + gold_value
    end,
    request_money = function(self, gold_value, sender)
      if gold_value <= self.gold then
        self.gold = self.gold - gold_value
        self:send(sender, "send_money")
        __gold_pickup_time = __get_time() + 0.2
      else
        return __play_sound("assets/sound/vendingmachine_unhappy.wav")
      end
    end,
    die = function(self, msg, sender)
      local magnitude = 2000
      for i = 1, self.gold / 10 do
        local o = Goldbar()
        local vel = random_direction(magnitude)
        vel[2] = -magnitude
        vel[1] = magnitude / 2 - __random() * magnitude
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
        self:send(o.id, 'set_vel', vel)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GoldHolder",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GoldHolder = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      self.food = 100
      self.next_hunger = 0
    end,
    step = function(self, dt, sender)
      if self.next_hunger < __get_time() then
        self.next_hunger = __get_time() + 1.0
        if 0 < self.food then
          self.food = self.food - 1
        elseif self.food == 0 then
          return self:send(self.id, 'dmg', {
            pts = 20
          })
        end
      end
    end,
    give_food = function(self, food, sender)
      __food_pickup_time = __get_time() + 0.3
      self.food = self.food + food
      if 99 < self.food then
        self.food = 99
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Hungers",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Hungers = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self)
      self.food_value = 5
    end,
    activate = function(self, msg, sender)
      return self:send(msg.activator_id, 'give_food', self.food_value)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GivesFood",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GivesFood = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      __assert_with_msg(self.gold_value, 'gold_value')
      __play_sound("assets/sound/pickup_gold.wav")
      __gold_pickup_time = __get_time() + 0.3
      local b = Text()
      self:send(b.id, 'mixin', 'Yellow')
      self:send(b.id, 'set_pos', {
        self.x,
        self.y - 60
      })
      self:send(b.id, 'set_vel', {
        0,
        -50 - __cosmetic_random() * 10
      })
      self:send(b.id, 'set_text', "$" .. self.gold_value)
      return self:send(msg.activator_id, 'give_gold', self.gold_value)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GivesGold",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GivesGold = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      self.sparkle_ps:update(dt)
      return self.sparkle_ps:setPosition(self.x, self.head_y or self.y)
    end,
    draw = function(self, msg, sender)
      return love.graphics.draw(self.sparkle_ps)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/sparkle.png")
      self.sparkle_ps = love.graphics.newParticleSystem(img, 30)
      self.sparkle_ps:setParticleLifetime(0.1, 0.5)
      self.sparkle_ps:setAreaSpread('normal', 5, 5)
      self.sparkle_ps:setEmissionRate(self.sparkle_magic or 2)
      self.sparkle_ps:setSizes(0.1, 0.3, 0.4)
      self.sparkle_ps:setSpin(1, 5)
      return self.sparkle_ps:setRotation(-100, 100)
    end,
    __base = _base_0,
    __name = "Sparkles",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Drawable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Sparkles = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self:_mixin(CastsShadow)
      self.shadow_size = 16
      self.sprite = __load_image("assets/gfx/goldbar.png")
      self:_mixin(GivesGold)
      self.gold_value = 10
      _parent_0.mixins(self)
      self:send(self.id, 'mixout', 'ContactableInTime')
      self:_mixin(Contactable)
      return self:_mixin(Sparkles)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Goldbar",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Goldbar = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    touch_ground = function(self, msg, sender)
      local o = Smoke()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
      __play_sound("assets/sound/diamond_break.wav")
      return self:send(self.id, 'remove')
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DiesWhenTouchingTheGround",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DiesWhenTouchingTheGround = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, dt, sender)
      if self.diestouchingground_in_time_start_time + self.var_diestouchingground_in_time_life_time < __get_time() then
        self:send(self.id, "mixin", "DiesWhenTouchingTheGround")
        self:send(self.id, "mixin", "FlashesWhite")
        self:send(self.id, "mixout", "DiesWhenTouchingTheGroundInTime")
        if self.touching_ground then
          local o = Smoke()
          self:send(o.id, 'set_pos', {
            self.x,
            self.y
          })
          __play_sound("assets/sound/diamond_break.wav")
          return self:send(self.id, 'remove')
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.var_diestouchingground_in_time_life_time = 1
      self.diestouchingground_in_time_start_time = __get_time()
    end,
    __base = _base_0,
    __name = "DiesWhenTouchingTheGroundInTime",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DiesWhenTouchingTheGroundInTime = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/diamond.png")
      self:_mixin(GivesGold)
      self.gold_value = 10
      _parent_0.mixins(self)
      self:_mixin(Stepper)
      self:_mixin(CastsShadow)
      self:_mixin(Sparkles)
      self:_mixin(ShortLived)
      self:_mixin(ContactableInTime)
      self.var_short_lived_life_time = 3
      self.sparkle_ps:setAreaSpread('normal', 2, 2)
      self.shadow_size = 8
      return self:add_handler('remove', Diamond.remove)
    end,
    remove = function(self, msg, sender)
      local o = Smoke()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
      return __play_sound("assets/sound/diamond_break.wav")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Diamond",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Diamond = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/doublejumppotion.png")
      self.activate_mixins = {
        "DoubleJumper",
        'Flashes'
      }
      self.pickup_message = {
        "You got",
        "double jump!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Doublejumppotion",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Doublejumppotion = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self:_mixin(Cure)
      self.activate_mixins = {
        "Flashes"
      }
      self.sprite = __load_image("assets/gfx/cure.png")
      self.pickup_message = {
        "You got",
        "the antidote!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Antidoteflask",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Antidoteflask = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/poison.png")
      self.activate_mixins = {
        "Poisoned"
      }
      self.pickup_message = {
        "Poisoned!",
        "",
        "Find a cure!"
      }
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Poisonflask",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Poisonflask = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixin = function(self, msg, sender)
      if msg == 'HasKey' then
        self.number_of_keys = self.number_of_keys + 1
      end
    end,
    die = function(self, msg, sender)
      return self:send(Key().id, 'set_pos', {
        self.x,
        self.y
      })
    end,
    request_key = function(self, msg, sender)
      self:send(sender, 'receive_key', {
        self.x,
        self.y
      })
      self.number_of_keys = self.number_of_keys - 1
      if self.number_of_keys <= 0 then
        self:send(self.id, 'mixout', 'HasKey')
        return self:send(self.id, 'mixout', 'Sparkles')
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.number_of_keys = 0
      self.sparkle_magic = 20
    end,
    __base = _base_0,
    __name = "HasKey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  HasKey = _class_0
end
do
  local _parent_0 = ItemGrantsMixin
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/key.png")
      self.activate_mixins = {
        "HasKey",
        "FlashesYellow",
        "Sparkles"
      }
      self.pickup_message = {
        "You got",
        "the key!",
        "",
        "Unlock doors!"
      }
      _parent_0.mixins(self)
      self.sparkle_magic = 10
      return self:_mixin(Sparkles)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Key",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Key = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jumppad.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Sprite)
      self:_mixin(Contactable)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      return self:_mixin(PushesVertically)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Jumppad",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Jumppad = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self:_mixin(GivesHP)
      self:_mixin(GivesFood)
      self.sprite = __load_image("assets/gfx/turkey.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Turkey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Turkey = _class_0
end
do
  local _parent_0 = Item
  local _base_0 = {
    mixins = function(self)
      self:_mixin(PermanentHPImprovement)
      self.sprite = __load_image("assets/gfx/hp_up.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "HPupbox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  HPupbox = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      __play_sound("assets/sound/vendingmachine_activate.wav")
      local o = Turkey()
      return self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SellsTurkey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SellsTurkey = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    die = function(self, msg, sender)
      __screen_shake = __get_time() + 0.200
      __play_sound("assets/sound/explosion.wav")
      local magnitude = 300
      for i = 1, 1 do
        local o = ExplosionDebris()
        self:send(o.id, 'set_pos', {
          self.x,
          self.y
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Popsondeath",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Popsondeath = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    add_injected_fields = function(self, msg, sender)
      if self.drop_injections == nil then
        self.drop_injections = { }
      end
      for field, value in pairs(msg) do
        self.drop_injections[field] = value
      end
    end,
    dropped_item = function(self, msg, sender)
      if self.drop_injections == nil then
        return 
      end
      self:send(msg.id, 'add_injected_fields', self.drop_injections)
      return self:send(msg.id, 'set_fields', self.drop_injections)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "InjectFieldsIntoDroppedItems",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  InjectFieldsIntoDroppedItems = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BBoxed)
      self:_mixin(Contactable)
      self:_mixin(Damageable)
      self:_mixin(RoomOccupier)
      self:_mixin(AngledSprite)
      self:_mixin(ShortLivedDies)
      self:_mixin(Popsondeath)
      self:_mixin(DropsItemOnDeath)
      self:_mixin(InjectFieldsIntoDroppedItems)
      self:_mixin(CastsShadow)
      self.shadow_size = 8
      self.var_short_lived_life_time = 1
      self.bbox_radius = 8
      self.dmg_pts = 20
      self.faction = 'bad'
      self.hp = 10
      self.mass = 0.4
      self.friction = 100
      self.restitution = 0.1
      self.sprite = __load_image("assets/gfx/gashapon_ball.png")
      self.scale = 0.5
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GashaponBall",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GashaponBall = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BBoxed)
      self:_mixin(Contactable)
      self:_mixin(Damageable)
      self:_mixin(RoomOccupier)
      self:_mixin(AngledSprite)
      self:_mixin(Popsondeath)
      self:_mixin(DropsItemOnDeath)
      do
        local _accum_0 = { }
        local _len_0 = 1
        for i, x in ipairs(__dried_goods) do
          _accum_0[_len_0] = __get_class_from_string(x)
          _len_0 = _len_0 + 1
        end
        self.dropped_object_classes = _accum_0
      end
      self.var_short_lived_life_time = 1
      self.bbox_radius = 8
      self.dmg_pts = 20
      self.faction = 'bad'
      self.hp = 10
      self.mass = 0.4
      self.friction = 100
      self.restitution = 0.1
      self.sprite = __load_image("assets/gfx/gashapon_ball.png")
      self.scale = 0.5
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ClosedGashaponBall",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ClosedGashaponBall = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      return self:send(sender, 'request_money', 5)
    end,
    send_money = function(self, msg, sender)
      self.sales = self.sales + 1
      __play_sound("assets/sound/vendingmachine_activate.wav")
      local cls = nil
      self:send(self.id, 'mixin', 'Flashes')
      if math.abs(__random()) < 0.5 then
        cls = Turkey
      elseif math.abs(__random()) < 0.4 then
        if math.abs(__random()) < 0.6 then
          cls = Coffee
        else
          cls = Antidoteflask
        end
      else
        local items = {
          HPupbox,
          Poisonflask
        }
        cls = items[math.floor(__random() * 10) % #items + 1]
      end
      local o = cls()
      local target = {
        self.x,
        self.y
      }
      if 0.5 < math.abs(__random()) then
        target[1] = target[1] + 30
      else
        target[1] = target[1] - 30
      end
      return self:send(o.id, 'set_pos', target)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sales = 0
    end,
    __base = _base_0,
    __name = "SellsItems",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SellsItems = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    activate = function(self, msg, sender)
      return self:send(sender, 'request_money', 10)
    end,
    send_money = function(self, msg, sender)
      self.sales = self.sales + 1
      __play_sound("assets/sound/vendingmachine_activate.wav")
      self:send(self.id, 'mixin', 'Flashes')
      local o = GashaponBall()
      do
        local _accum_0 = { }
        local _len_0 = 1
        for i, x in ipairs(__dried_goods) do
          _accum_0[_len_0] = __get_class_from_string(x)
          _len_0 = _len_0 + 1
        end
        o.dropped_object_classes = _accum_0
      end
      local target = {
        self.x,
        self.y
      }
      if 0.5 < math.abs(__random()) then
        target[1] = target[1] + 30
      else
        target[1] = target[1] - 30
      end
      return self:send(o.id, 'set_pos', target)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sales = 0
    end,
    __base = _base_0,
    __name = "SellsDryItems",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SellsDryItems = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      return self:_mixin(BBoxSprite)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VendingMachineBlock",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VendingMachineBlock = _class_0
end
do
  local _parent_0 = VendingMachineBlock
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jihanki_debris1.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VendingMachineBlock1",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VendingMachineBlock1 = _class_0
end
do
  local _parent_0 = VendingMachineBlock
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jihanki_debris2.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VendingMachineBlock2",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VendingMachineBlock2 = _class_0
end
do
  local _parent_0 = VendingMachineBlock
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jihanki_debris3.png")
      return _parent_0.mixins(self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VendingMachineBlock3",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VendingMachineBlock3 = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler('init', VendingmachinePhysical.init)
      self:add_handler('dmg', VendingmachinePhysical.dmg)
      self:add_handler('die', VendingmachinePhysical.die)
      self.sprite = __load_image("assets/gfx/jihanki_broken.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Damageable)
      self:_mixin(Explodesondeath)
      self:_mixin(DropsItemsOnDeath)
      self:_mixin(PlacedOntoFloor)
      self.dropped_object_classes = {
        Doublejumppotion
      }
    end,
    init = function(self, msg, sender)
      self.mass = 30
      self.hp = 500
      self.speed_max = 5000
      self.dmg_pts = 20
      self.attack_range = 150
    end,
    dmg = function(self, msg, sender)
      local velx = 1
      if msg.atk_origin then
        if msg.atk_origin[1] < self.x then
          velx = 1
        else
          velx = -1
        end
      end
      self:send(self.id, 'set_vel', {
        velx * 5000,
        -3000
      })
      return __play_sound("assets/sound/gib.wav")
    end,
    die = function(self, msg, sender)
      for i = 1, 7 do
        local o = Fire()
        self:send(o.id, 'set_pos', {
          self.x - 40 + __cosmetic_random() * 40 * 2,
          self.y + 20 + __cosmetic_random() * 30
        })
        self:send(o.id, 'set_vel', {
          __cosmetic_random() * 40,
          -math.abs(__cosmetic_random()) * 40
        })
      end
      local magnitude = 900
      local o = VendingMachineBlock1()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y
      })
      self:send(o.id, 'set_vel', random_direction(magnitude))
      o = VendingMachineBlock2()
      self:send(o.id, 'set_pos', {
        self.x + 40,
        self.y
      })
      self:send(o.id, 'set_vel', random_direction(magnitude))
      o = VendingMachineBlock3()
      self:send(o.id, 'set_pos', {
        self.x,
        self.y - 40
      })
      return self:send(o.id, 'set_vel', random_direction(magnitude))
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VendingmachinePhysical",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VendingmachinePhysical = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    make_bbox = function(self, msg, sender)
      self.fixture:setMask(REGULAR_CATEGORY, DMG_CATEGORY)
      self.fixture:setCategory(GHOST_DMG_CATEGORY)
      return self.body:setGravityScale(0)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GhostDmgBBox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GhostDmgBBox = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    dmg = function(self, msg, sender)
      for key, klass in pairs(self.replacement_classes) do
        local v = klass()
        self:send(v.id, 'mixin', 'DamageableInTime')
        self:send(v.id, 'set_pos', {
          self.x,
          self.y
        })
        local velx = 1
        if __random() < 0.5 then
          velx = -1
        end
        self:send(v.id, 'set_vel', {
          velx * 5000,
          -3000
        })
        self:send(self.id, 'remove')
        __play_sound("assets/sound/gib.wav")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "DamageReplacesObject",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DamageReplacesObject = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jihanki.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(Sprite)
      self:_mixin(Damageable)
      self:_mixin(Activatable)
      self:_mixin(SellsItems)
      self:_mixin(Explodesondeath)
      self:_mixin(DamageReplacesObject)
      self.w = self.sprite:getWidth()
      self.h = self.sprite:getHeight()
      self:_mixin(RectangleBBox)
      self:_mixin(GhostDmgBBox)
      self.dmg_pts = 20
      self.attack_range = 150
      self.replacement_classes = {
        VendingmachinePhysical
      }
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Vendingmachine",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Vendingmachine = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", GashaponPhysical.init)
      self.sprite = __load_image("assets/gfx/gashapon_broken.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Damageable)
      self:_mixin(Explodesondeath)
      self:_mixin(DropsItemsOnDeath)
      self:_mixin(PlacedOntoFloor)
      self.dropped_object_classes = {
        Doublejumppotion
      }
    end,
    init = function(self, msg, sender)
      self.mass = 30
      self.hp = 500
      self.speed_max = 5000
      self.dmg_pts = 20
      self.attack_range = 150
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "GashaponPhysical",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GashaponPhysical = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Cardboardbox.init)
      self:add_handler("step", Cardboardbox.step)
      self.sprite_angles = {
        __load_image("assets/gfx/cardboardbox0.png"),
        __load_image("assets/gfx/cardboardbox1.png"),
        __load_image("assets/gfx/cardboardbox2.png"),
        __load_image("assets/gfx/cardboardbox3.png")
      }
      self.sprite = self.sprite_angles[1]
      self:_mixin(CastsShadow)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Damageable)
      self:_mixin(Explodesondeath)
      return self:_mixin(PlacedOntoFloor)
    end,
    init = function(self, msg, sender)
      self.mass = 0.1
      self.hp = 500
      self.speed_max = 5000
      self.dmg_pts = 20
      self.attack_range = 150
    end,
    step = function(self, msg, sender)
      local r = self.angle % (3.14 * 2)
      local m = 3.14
      local i = 1 + math.floor(((r + 0.4) / (m * 2)) * #self.sprite_angles) % #self.sprite_angles
      self.sprite = self.sprite_angles[i]
      return self.mesh:setTexture(self.sprite)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Cardboardbox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Cardboardbox = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("draw", Gashapon.draw)
      self.sprite = __load_image("assets/gfx/gashapon.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(Sprite)
      self:_mixin(Damageable)
      self:_mixin(Activatable)
      self:_mixin(SellsDryItems)
      self:_mixin(Explodesondeath)
      self:_mixin(DamageReplacesObject)
      self:_mixin(PlacedOntoFloor)
      self.w = self.sprite:getWidth()
      self.h = self.sprite:getHeight()
      self:_mixin(RectangleBBox)
      self:_mixin(GhostDmgBBox)
      self.dmg_pts = 20
      self.attack_range = 150
      self.replacement_classes = {
        GashaponPhysical
      }
      self.sprite_ball = __load_image("assets/gfx/gashapon_ball.png")
      self.random_gen = love.math.newRandomGenerator(1)
    end,
    draw = function(self, msg, sender)
      self.random_gen:setSeed(self.sales)
      local ball_center = (self.sprite_ball:getWidth() * 0.3) / 2
      local r = 0.4
      local w = self.sprite:getWidth() * 0.4
      for i = 1, 32 do
        love.graphics.draw(self.sprite_ball, self.x + (self.random_gen:random() - 0.5) * w - 4, self.y + (self.random_gen:random() - 0.5) * w - 16, self.random_gen:random(), 0.3, 0.3)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Gashapon",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Gashapon = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Chest.init)
      self.sprite = __load_image("assets/gfx/chest.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Damageable)
      return self:_mixin(Explodesondeath)
    end,
    init = function(self, msg, sender)
      self.mass = 10
      self.hp = 100
      self.speed_max = 5000
      self.dmg_pts = 20
      self.attack_range = 150
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Chest",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Chest = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/lamp.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:_mixin(Sprite)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Lamp",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Lamp = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BackgroundSprite)
      self:_mixin(Doorable)
      self:_mixin(PlacedOntoFloor)
      self.sprite = __load_image("assets/gfx/door002.png")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Door",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Door = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    touch = function(self, other_id, sender)
      return self:send(other_id, 'request_key')
    end,
    receive_key = function(self, other_id, sender)
      __play_sound("assets/sound/explosion.wav")
      self:send(self.id, 'mixin', 'Doorable')
      self:send(self.id, 'mixin', 'FlashesYellow')
      self:send(self.id, 'mixin', 'Activatable')
      return self:send(self.id, 'mixout', 'OpensByKey')
    end,
    mixin = function(self, msg, sender)
      if msg == 'Doorable' then
        self.sprite = __load_image("assets/gfx/door002.png")
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "OpensByKey",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Touchable'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  OpensByKey = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BackgroundSprite)
      self:_mixin(OpensByKey)
      self:_mixin(RoomOccupier)
      self:_mixin(PlacedOntoFloor)
      self.sprite = __load_image("assets/gfx/door_locked002.png")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Lockeddoor",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Lockeddoor = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BackgroundSprite)
      self:_mixin(Doorable)
      self:_mixin(PlacedOntoFloor)
      self.sprite = __load_image("assets/gfx/door002.png")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Upstairs",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Upstairs = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    step = function(self, msg, sender)
      if 50 < distance(self.x, self.y, player.x, player.y) then
        if __black_bands then
          __black_bands = false
          __black_bands_time = __get_time() + 1
        end
        return 
      end
      if not __black_bands then
        __black_bands = true
        __play_sound("assets/sound/leaving_room.wav")
        __black_bands_time = __get_time()
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "ShowsBlackBands",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'Stepper'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ShowsBlackBands = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(BackgroundSprite)
      self:_mixin(Doorable)
      self:_mixin(ShowsBlackBands)
      self:_mixin(PlacedOntoFloor)
      self.sprite = __load_image("assets/gfx/door002.png")
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Downstairs",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Downstairs = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = { }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x = 0
      self.y = 100
    end,
    __base = _base_0,
    __name = "Camera",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Camera = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(PainfulTouch)
      self:_mixin(RoomOccupier)
      self:_mixin(Sprite)
      self.sprite = __load_image("assets/gfx/spike.png")
      self.dmg_pts = 10000
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Spike",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Spike = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Barrel.init)
      self.sprite = __load_image("assets/gfx/barrel.png")
      self:_mixin(CastsShadow)
      self.shadow_size = 15
      self:_mixin(BBoxSprite)
      self:_mixin(BBoxedQuad)
      self:_mixin(Damageable)
      self:_mixin(Dissolves)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(PlayersHitShakesScreen)
      if math.abs(__random()) < 0.5 then
        self:_mixin(DropsItemsOnDeath)
        self.dropped_object_classes = {
          Goldbar
        }
      end
    end,
    init = function(self, msg, sender)
      self.mass = 20
      self.hp = 100
      self.speed_max = 5000
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Barrel",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Barrel = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/vase_piece.png")
      self:_mixin(CastsShadow)
      self.shadow_size = 8
      self:_mixin(DamageableInTime)
      self:_mixin(PlaysSoundWhenDead)
      self:_mixin(PuffsWhenDead)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self.mass = 0.4
      self.friction = 100
      self.restitution = 0.1
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "VasePiece",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  VasePiece = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.dissolve_class = 'VasePiece'
      self.dissolve_count = 3
      self.sprite = __load_image("assets/gfx/vase.png")
      self:_mixin(CastsShadow)
      self.shadow_size = 15
      self:_mixin(BBoxed)
      self:_mixin(AngledSprite)
      self:_mixin(Damageable)
      self:_mixin(Dissolves)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(PlayersHitShakesScreen)
      if math.abs(__random()) < 0.5 then
        self:_mixin(DropsItemsOnDeath)
        self.dropped_object_classes = {
          Goldbar
        }
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Vase",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Vase = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.spine_scale = 0.9
      self.spine_skeleton_file = "assets/skeleton/demon"
      self.spine_h_adjustment = 80
      self:_mixin(Baddie)
      self:_mixin(AnimatedRunner)
      self:_mixin(Attacker)
      self:_mixin(BBoxed)
      self:_mixin(Bleeds)
      self:_mixin(CastsShadow)
      self:_mixin(Contactable)
      self:_mixin(Controlled)
      self:_mixin(DamageOnContact)
      self:_mixin(Damageable)
      self:_mixin(FacesDirectionByVelocity)
      self:_mixin(GibableWithBones)
      self:_mixin(PlayerFollower)
      self:_mixin(RandomJumper)
      self:_mixin(RoomOccupier)
      self:_mixin(SpineSkeleton)
      self:_mixin(GoldHolder)
      self:_mixin(PlayersHitSlowsTime)
      self.hat_name = 'oni_mask'
      self:_mixin(HasHat)
      self.air_control = 0.2
      self.bbox_radius = 16
      self.dmg_pts = 10
      self.faction = 'bad'
      self.hp = 75
      self.restitution = 0.0
      self.scale = 1
      self.var_damage_on_contact_time = 1
      self.walk_speed = 150
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Imp",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Imp = _class_0
end
do
  local _parent_0 = Imp
  local _base_0 = {
    mixins = function(self)
      _parent_0.mixins(self)
      self:_mixin(Poisoned)
      self.air_control = 0.2
      self.bbox_radius = 16
      self.dmg_pts = 10
      self.faction = 'bad'
      self.hp = 100
      self.restitution = 0.0
      self.scale = 1
      self.var_damage_on_contact_time = 1
      self.walk_speed = 100
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Poisonedimp",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Poisonedimp = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    mixins = function(self)
      return self:_mixin(PlayersHitShakesScreen)
    end,
    die = function(self, msg, sender)
      __assert_with_msg(self.dmg_pts, 'dmg_pts')
      __assert_with_msg(self.attack_range, 'attack_range')
      __screen_shake = __get_time() + 0.200
      __play_sound("assets/sound/explosion.wav")
      __white_screen_time = __get_time() + 0.1
      for key, o in pairs(__damageables) do
        local _continue_0 = false
        repeat
          if o.room ~= self.room then
            _continue_0 = true
            break
          end
          if o.id == self.id then
            _continue_0 = true
            break
          end
          if self.attack_range < distance(self.x, self.y, o.x, o.y) then
            _continue_0 = true
            break
          end
          self:send(o.id, 'dmg', {
            pts = self.dmg_pts,
            atk_origin = {
              self.x,
              self.y
            }
          })
          _continue_0 = true
        until true
        if not _continue_0 then
          break
        end
      end
      for i = 1, 7 do
        local o = Fire()
        self:send(o.id, 'set_pos', {
          self.x - 40 + __cosmetic_random() * 40 * 2,
          self.y
        })
        self:send(o.id, 'set_vel', {
          __cosmetic_random() * 10,
          -math.abs(__cosmetic_random()) * 3
        })
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Explodesondeath",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Explodesondeath = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:add_handler("init", Explodingbarrel.init)
      self.sprite = __load_image("assets/gfx/barrel_wildfire.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Damageable)
      self:_mixin(Dissolves)
      self:_mixin(SmokeWhenDead)
      return self:_mixin(Explodesondeath)
    end,
    init = function(self, msg, sender)
      self.mass = 20
      self.hp = 20
      self.speed_max = 5000
      self.light_range = 40
      self.light_colour = {
        0,
        255,
        0
      }
      self.attack_range = 150
      self.dmg_pts = 100
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Explodingbarrel",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Explodingbarrel = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if not self.light then
        return 
      end
      self.light:setPosition(self.x, self.y)
      return self.light:setDirection(math.sin(__get_time() / 10) * 3.1416)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "MovingLight",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MovingLight = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self, msg, sender)
      self.bbox_type = 'static'
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "StaticBbox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  StaticBbox = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.bbox_type = 'static'
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:_mixin(BBoxed)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Ceilingattachment",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Ceilingattachment = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    init = function(self, msg, sender)
      if self.world_obj == nil then
        return 
      end
      if self.light_colour then
        self.light = self.room.lightWorld:newLight(self.world_obj.x, self.world_obj.y, self.light_colour[1], self.light_colour[2], self.light_colour[3])
      else
        self.light = self.room.lightWorld:newLight(self.world_obj.x, self.world_obj.y, 255, 255, 255)
      end
      self.light:setRange(self.world_obj.properties.range or self.light_range or 300)
      if self.world_obj.properties.colour then
        local r, g, b = string.match(self.world_obj.properties.colour, "(..)(..)(..)")
        self.light:setColor(tonumber(r, 16), tonumber(g, 16), tonumber(b, 16))
      end
      self.y_attachment = 0
      self.scale = 1
    end,
    die = function(self, msg, sender)
      return self.room.lightWorld:remove(self.light)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Lights",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Lights = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = { }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.button_sprite = __load_image("assets/gfx/button_z_down.png")
    end,
    __base = _base_0,
    __name = "NeedsZButtonPushed",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.needs = {
    'ShowButtonWhenClose'
  }
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  NeedsZButtonPushed = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      local scale = self.glow_strobe + math.abs(math.sin(__get_time() * 5)) * 0.5
      love.graphics.setColor(255, 255, 255, scale * 100)
      love.graphics.draw(self.sprite_glow, self.x, self.y + self.sprite:getHeight() / 4, 0, scale, scale, self.sprite_glow:getWidth() / 2, self.sprite_glow:getHeight() / 2)
      return love.graphics.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sprite_glow = __load_image("assets/gfx/light.png")
      self.glow_strobe = 1
    end,
    __base = _base_0,
    __name = "Glows",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Glows = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      if self.glow_strobe_time < __get_time() then
        if 0.7 < math.abs(__cosmetic_random()) then
          self.glow_strobe_time = __get_time() + math.abs(__cosmetic_random()) * 0.5
          self.glow_strobe = math.abs(__cosmetic_random()) * 0.5
        else
          self.glow_strobe_time = __get_time() + 1
          self.glow_strobe = 0.5 + math.abs(__cosmetic_random()) * 1.5
        end
      end
      local scale = self.glow_strobe + math.abs(math.sin(__get_time() * 5)) * 0.5
      return self.light:setRange(scale * 200)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.sprite_glow = __load_image("assets/gfx/light.png")
      self.glow_strobe_time = 0
      self.glow_strobe = 1
    end,
    __base = _base_0,
    __name = "Strobes",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Strobes = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/lightbulb02.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Lights)
      self:_mixin(MovingLight)
      self:_mixin(Attachestoceiling)
      self:add_handler("init", Light.init)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(Drawable)
      self:_mixin(BBoxSprite)
      return self:_mixin(Glows)
    end,
    init = function(self, msg, sender)
      self.mass = 1
      self.hp = 20
      self.speed_max = 5000
      self.light_range = 40
      self.light_colour = {
        0,
        255,
        0
      }
      self.attack_range = 150
      self.dmg_pts = 100
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Light",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Light = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/jihanki_debris3.png")
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(Thrower)
      self.facing_direction = -1
      self.throw_cooldown_time = 1.0
      self.throwing_object_class = ThrowingKunai
      self.throw_speed = 3000
      return self:add_handler("step", Speartrap.step)
    end,
    step = function(self, dt, sender)
      return self:send(self.id, 'cmd_secondary')
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Speartrap",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Speartrap = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self.sprite = __load_image("assets/gfx/drop.png")
      self:_mixin(Piercingattack)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(BBoxedQuad)
      self:_mixin(BBoxSprite)
      self:_mixin(DamageOnContact)
      self:_mixin(RemovedOnDamage)
      self:_mixin(ShortLived)
      self:_mixin(ShrinksByShortTimeLeft)
      self.var_short_lived_life_time = 1
      self:_mixin(RotatedRight)
      self.dmg_pts = 50
      self.speed_max = 3000
      self.faction = 'drop'
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Drop",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Drop = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw_front = function(self, msg, sender)
      return love.graphics.draw(self.ps_fog)
    end,
    step = function(self, dt, sender)
      self.ps_fog:update(dt)
      self.ps_fog:setPosition(self.x, self.y)
      return self.ps_fog:emit(1)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/smoke_breathable.png")
      self.ps_fog = love.graphics.newParticleSystem(img, 1000)
      self.ps_fog:setParticleLifetime(1, 5)
      self.ps_fog:setAreaSpread('normal', 200, 0)
      self.ps_fog:setSizes(1, 2.5)
      self.ps_fog:setSpin(-3, 3)
      self.ps_fog:setLinearAcceleration(-30, 0, 30, -5)
      return self.ps_fog:setColors(255, 255, 255, 50, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "Foggy",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Foggy = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(Drawable)
      return self:_mixin(Foggy)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Fog",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Fog = _class_0
end
do
  local _parent_0 = Component
  local _base_0 = {
    draw = function(self, msg, sender)
      return love.graphics.draw(self.ps_drip)
    end,
    step = function(self, dt, sender)
      self.ps_drip:update(dt)
      self.ps_drip:setPosition(self.x, self.y)
      return self.ps_drip:emit(1)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      local img = __load_image("assets/gfx/drop.png")
      self.ps_drip = love.graphics.newParticleSystem(img, 20)
      self.ps_drip:setParticleLifetime(1, 5)
      self.ps_drip:setSizes(1, 1.5)
      self.ps_drip:setLinearAcceleration(0, 30, 0, 30)
      return self.ps_drip:setColors(255, 255, 255, 100, 255, 255, 255, 0)
    end,
    __base = _base_0,
    __name = "Drips",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Drips = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      self:_mixin(Drips)
      self:_mixin(Drawable)
      self.facing_direction = -1
      self.throw_cooldown_time = 1.0
      self.throwing_object_class = Drop
      self.throw_speed = 3000
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Drip",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Drip = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(RoomOccupier)
      self:_mixin(Stepper)
      return self:add_handler("init_full", Randomgreatsword.init_full)
    end,
    init_full = function(self, msg, sender)
      local choices = {
        Shortsword
      }
      local idx = math.floor(__random() * 10) % #choices + 1
      local cls = choices[idx]
      local o = cls()
      self:send(o.id, 'set_pos', {
        self.x + math.abs(__random()) * self.world_obj.width,
        self.y
      })
      self:send(o.id, 'set_room', self.room)
      if self.world_obj.properties.child_mixins then
        return self:send(o.id, 'mixin', self.world_obj.properties.child_mixins)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Randomgreatsword",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Randomgreatsword = _class_0
end
local __hud_objects = { }
do
  local _parent_0 = Component
  local _base_0 = {
    mixed_in = function(self, msg, sender)
      return table.insert(__hud_objects, self)
    end,
    remove = function(self, msg, sender)
      for key, obj in pairs(__hud_objects) do
        if obj == self then
          table.remove(__hud_objects, key)
        end
      end
    end,
    set_subject = function(self, msg, sender)
      self.subject = msg
    end,
    draw = function(self, msg, sender)
      if __get_time() < __add_to_score_time then
        self.shake = math.sin(__get_time() * 50)
      else
        self.shake = 0
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "HudObject",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  HudObject = _class_0
end
do
  local _parent_0 = Object
  local _base_0 = {
    mixins = function(self)
      self:_mixin(HudObject)
      self:add_handler("draw", Score.draw)
      self.x = HUD_SCORE_X + 18
      self.y = HUD_SCORE_Y
      self.shake = 0
    end,
    draw = function(self, msg, sender)
      __draw_text("score", self.x, self.y - 20, 0, 0.5)
      return __draw_text("" .. self.subject.score, self.x + self.shake * 2, self.y + self.shake * 2, 0, 0.5)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, ...)
      return _parent_0.__init(self, ...)
    end,
    __base = _base_0,
    __name = "Score",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Score = _class_0
end
love.mousereleased = function(x, y, button) end
local __on_level_object_creation
__on_level_object_creation = function(o, room)
  current_room = room
  local name = o.type
  local cls = __get_class_from_string(name)
  if cls then
    local n = cls()
    n.world_obj = o
    n.world_obj.object = n
    n.name = name
    __world:send(n.id, 'set_pos', {
      o.x,
      o.y
    })
    return n
  end
end
local __on_level_init_full
__on_level_init_full = function(o, room)
  poll_messages()
  __world:send(o.id, 'init_full')
  return poll_messages()
end
local game_over_font = { }
local ____run_drops
____run_drops = function(branch, level)
  if branch.type == 'one of' then
    local total_chance = 0
    for drop_name in pairs(branch.drops) do
      local drop = branch.drops[drop_name]
      total_chance = total_chance + drop.chance
    end
  elseif branch.type == 'one at level' then
    for drop_name in pairs(branch.drops) do
      local drop = branch.drops[drop_name]
      if drop.level == level then
        if startswith(drop_name, '(') then
          local macro_branch = __drops[drop_name]
          ____run_drops(macro_branch, level)
        end
        return 
      end
    end
    return __assert_with_msg(false, 'could not find level')
  end
end
local __run_drops
__run_drops = function(name, level)
  local branch = __drops[name]
  return ____run_drops(branch, level)
end
local __load_drops
__load_drops = function(name)
  local contents, size = love.filesystem.read(name)
  local pos, err
  __drops, pos, err = json.decode(contents, 1, nil)
  return __run_drops('monsters', 1)
end
local __load_replay
__load_replay = function()
  for line in love.filesystem.lines('replay.log') do
    local row = { }
    for o in string.gmatch(line, "[^%s]+") do
      table.insert(row, tonumber(o))
    end
    table.insert(__replay, row)
  end
end
camera_change_time = 0
local __update_camera
__update_camera = function(dt)
  local cam_org = vector.new(camera._x, camera._y)
  local ent_org = vector.new(player.x - windowWidth / 2, player.y - windowHeight / 1.5)
  local sub = ent_org - cam_org
  sub:normalize_inplace()
  local dist = ent_org:dist(cam_org)
  camera:move(sub.x * dist * dt * 2, 0)
  return __clamp_camera(camera)
end
local __update
__update = function(dt)
  if __world_pause < __get_time() then
    __world_accumulator = __world_accumulator + dt
    while PHYSICS_STEP <= __world_accumulator do
      current_room.world:update(PHYSICS_STEP)
      __world_accumulator = __world_accumulator - PHYSICS_STEP
      for _, o in pairs(__steppers) do
        __world:send(o.id, 'physics_update', PHYSICS_STEP)
      end
      poll_messages()
    end
    for _, o in pairs(__steppers) do
      if o.room == current_room or o == player then
        __world:send(o.id, 'pre_step', dt)
        __world:send(o.id, 'step', dt)
      end
    end
    poll_messages()
    poll_messages()
    poll_messages()
    poll_messages()
    poll_messages()
    current_room.map:update(dt)
    __update_camera(dt)
    return current_room.lightWorld:update(dt)
  end
end
local __last_frame = 0
local __frame = 1
love.keypressed = function(key, scancode, isrepeat)
  if key == 'escape' then
    love.event.quit()
  end
  if player.hp <= 0 then
    love.event.quit("restart")
  end
  if key == "p" then
    __show_center_rect = not __show_center_rect
  end
  if key == "q" then
    local screenshot = love.graphics.newScreenshot()
    return screenshot:encode('png', os.time() .. '.png')
  end
end
local __draw_hp_bar
__draw_hp_bar = function(x, y, edge, w, h, ratio)
  love.graphics.setColor(255, 255, 255)
  love.graphics.rectangle("fill", x, y, w, h)
  love.graphics.setColor(255, 0, 0)
  if 0 < ratio then
    love.graphics.rectangle("fill", x + edge, y + edge, (w - edge * 2) * ratio, h - edge * 2)
  end
  return love.graphics.setColor(255, 255, 255)
end
local __draw_stamina_bar
__draw_stamina_bar = function(x, y, edge, w, h, ratio)
  love.graphics.setColor(255, 255, 255)
  love.graphics.rectangle("fill", x, y, w, h)
  love.graphics.setColor(255, 248, 159)
  if 0 < ratio then
    love.graphics.rectangle("fill", x + edge, y + edge, (w - edge * 2) * ratio, h - edge * 2)
  end
  return love.graphics.setColor(255, 255, 255)
end
local __draw_circle
__draw_circle = function(x, y, radius, ratio)
  local pi2 = 3.14 * 2
  local z = 3.14 * (1 - ratio)
  return love.graphics.arc('fill', 'closed', x, y, radius, pi2 - z, z)
end
local __snap
__snap = function(x, snap)
  if x % snap == 0 then
    return x
  else
    return x + (snap - x % snap)
  end
end
local __draw_hp_balls
__draw_hp_balls = function(x, y, edge, h, hp, max_hp)
  hp = math.floor(hp)
  local spacing = h + edge
  love.graphics.setColor(255, 255, 255)
  for i = 0, math.floor(max_hp / HP_PER_BALL) - 1 do
    love.graphics.circle("line", x + i * spacing, y + 2, h / 2)
  end
  love.graphics.setColor(255, 0, 0)
  local iend = math.floor(math.max(__snap(hp, HP_PER_BALL) / HP_PER_BALL, 1))
  for i = 0, iend - 1 do
    if i == iend - 1 and hp % HP_PER_BALL ~= 0 then
      __draw_circle(x + i * spacing, y + edge * 2, h / 2 - edge, ((hp % HP_PER_BALL) / HP_PER_BALL))
    else
      love.graphics.circle("fill", x + i * spacing, y + edge * 2, h / 2 - edge)
    end
  end
  return love.graphics.setColor(255, 255, 255)
end
local __draw_physics
__draw_physics = function()
  for key, body in pairs(current_room.world:getBodyList()) do
    for _, fixture in pairs(body:getFixtureList()) do
      local cat = fixture:getCategory()
      if cat == 1 then
        love.graphics.setColor(255, 0, 255, 100)
      elseif cat == 2 then
        love.graphics.setColor(255, 255, 0, 100)
      else
        love.graphics.setColor(0, 255, 255, 100)
      end
      local shape = fixture:getShape()
      local shape_type = shape:getType()
      if shape_type == 'circle' then
        love.graphics.circle("fill", body:getX(), body:getY(), shape:getRadius())
      elseif shape_type == 'polygon' then
        love.graphics.polygon('fill', body:getWorldPoints(shape:getPoints()))
      elseif shape_type == 'rectangle' then
        print(body)
      end
    end
  end
  return love.graphics.setColor(255, 255, 255)
end
local __draw_black_bands
__draw_black_bands = function()
  if __black_bands or __get_time() < __black_bands_time then
    local band_h = 0
    if __get_time() < __black_bands_time then
      band_h = (__black_bands_time - __get_time()) * 50
    else
      band_h = (__get_time() - __black_bands_time) * 50
    end
    if 50 < band_h then
      band_h = 50
    end
    love.graphics.setColor(0, 0, 0)
    love.graphics.rectangle("fill", 0, 0, windowWidth * 10, band_h)
    love.graphics.rectangle("fill", 0, windowHeight - band_h, windowWidth * 10, band_h)
    return love.graphics.setColor(255, 255, 255)
  end
end
love.draw = function()
  love.graphics.push()
  local shake = 0
  if __tick < __screen_shake then
    shake = math.sin(__tick) * 5
  end
  for _, d in pairs(__lighting_drawables) do
    if d.room == current_room then
      __world:send(d.id, 'draw_start', dt)
      __world:send(d.id, 'draw', dt)
      __world:send(d.id, 'draw_done', dt)
    end
  end
  love.graphics.scale(__screenWidth / windowWidth, __screenHeight / windowHeight)
  love.graphics.translate(-camera._x + shake, -camera._y + shake)
  love.graphics.setColor(0, 0, 0)
  if __get_time() < __white_screen_time then
    love.graphics.setColor(255, 255, 255)
  else
    love.graphics.setColor(0, 0, 0)
  end
  local w, h = love.graphics.getWidth() * 4, love.graphics.getHeight() * 4
  love.graphics.rectangle("fill", 0, -500, w, h)
  love.graphics.setColor(255, 255, 255)
  if current_room.map.layers['background3'] then
    current_room.map.layers['background3']:draw()
  end
  love.graphics.setColor(255, 255, 255)
  if current_room.map.layers['background2'] then
    current_room.map.layers['background2']:draw()
  end
  if current_room.map.layers['background'] then
    current_room.map.layers['background']:draw()
  end
  love.graphics.setColor(255, 255, 255)
  current_room.map.layers['Tile Layer 1']:draw()
  poll_messages()
  current_room.map.layers['Objects']:draw()
  for _, d in pairs(__background_drawables) do
    if d.room == current_room then
      __world:send(d.id, 'draw_start', dt)
      __world:send(d.id, 'draw', dt)
      __world:send(d.id, 'draw_done', dt)
    end
  end
  for _, d in pairs(drawables) do
    if d.room == current_room then
      __world:send(d.id, 'draw_start', dt)
      __world:send(d.id, 'draw', dt)
      __world:send(d.id, 'draw_done', dt)
    end
  end
  for _, d in pairs(__foreground_drawables) do
    if d.room == current_room then
      __world:send(d.id, 'draw_start', dt)
      __world:send(d.id, 'draw', dt)
      __world:send(d.id, 'draw_done', dt)
    end
  end
  poll_messages()
  for _, d in pairs(drawables) do
    if d.room == current_room then
      __world:send(d.id, 'draw_front', dt)
    end
  end
  poll_messages()
  if current_room.map.layers['web'] then
    current_room.map.layers['web']:draw()
  end
  love.graphics.pop()
  love.graphics.push()
  love.graphics.translate(-camera._x * 1.2, -camera._y * 1.2)
  love.graphics.pop()
  love.graphics.push()
  love.graphics.translate(-camera._x + shake, -camera._y + shake)
  __draw_black_bands()
  if __show_center_rect then
    __draw_physics()
  end
  love.graphics.pop()
  if 0 < player.hp then
    for _, o in pairs(__hud_objects) do
      __world:send(o.id, 'draw', dt)
    end
    poll_messages()
    __draw_text("samurai", 10, 0, 0, 0.5)
    __draw_hp_balls(HUD_HP_X + 20, 20 + 10, 1, 16, player.hp, player.hp_max)
    if player.gold ~= nil and 0 < player.gold then
      local r = 0
      if __get_time() < __gold_pickup_time then
        love.graphics.setColor(255, 255, 0)
        r = math.sin(__get_time() * 50)
      end
      __draw_text("GOLD", HUD_GOLD_X + 18, 0, 0, 0.5)
      __draw_text("$" .. player.gold, HUD_GOLD_X + 18 + r * 2, 20 + r * 2, 0, 0.5)
      if __get_time() < __gold_pickup_time then
        love.graphics.setColor(255, 255, 255)
      end
    end
    if player.throw_icon and player.throw_payload and 0 < player.throw_payload then
      __draw_text("ITEM", HUD_SECONDARY_X, 0, 0, 0.5)
      love.graphics.draw(player.throw_icon, HUD_SECONDARY_X - player.throw_icon:getWidth() / 2 - 2 + 20, 16 + 20, 0, 1, 1, player.throw_icon:getWidth() / 2, player.throw_icon:getHeight() / 2)
      __draw_text("" .. player.throw_payload, HUD_SECONDARY_X + 20, 20, 0, 0.5)
    end
    if __show_center_rect then
      __draw_text(player.room.name, windowWidth / 2, 50, 0, 0.5)
    end
    __draw_text("time ", HUD_TIME_X, 0, 0, 0.5)
    local r = 0
    if __get_time() < __food_pickup_time then
      love.graphics.setColor(0, 255, 0)
      r = math.sin(__get_time() * 50)
    elseif __get_time() < __food_take_away_time then
      love.graphics.setColor(255, 0, 0)
      r = math.sin(__get_time() * 50)
    end
    __draw_text(" " .. player.food, HUD_TIME_X + r * 2, 20 + r * 2, 0, 0.5)
    if __get_time() < __food_pickup_time then
      love.graphics.setColor(255, 255, 255)
    end
    if __message then
      local b = 0
      local v = (__message_remove_time - __get_time()) * 255
      love.graphics.setColor(255, 255, 255, v)
      local i = 0
      for _, msg in pairs(__message) do
        local len = string.len(msg)
        len = len * (20 * __message_size)
        local y = 80 + i * 20 * __message_size - b * 60
        __draw_text(msg, windowWidth / 2 - len / 2, y, 0, 0.5 * __message_size)
        i = i + 1
      end
      if __message_remove_time < __get_time() then
        __message_remove_time = 0
        __message = nil
      end
      return love.graphics.setColor(255, 255, 255)
    end
  else
    return __draw_text("GAME\nOVER", windowWidth / 2 - 4 * game_over_font_h / 2, windowHeight / 3)
  end
end
local __right_down = false
local __left_down = false
local __up_down = false
local __down_down = false
__down_down = false
local __primary_down = false
local __secondary_down = false
local __play_replay_frame
__play_replay_frame = function(frame)
  local o = __replay[frame]
  __tick = o[2]
  if o[3] == 0 and __right_down then
    __world:send(player.id, 'cmd_right_released')
    __right_down = false
  elseif o[3] == 1 and not __right_down then
    __world:send(player.id, 'cmd_right_pressed')
    __right_down = true
  end
  if o[4] == 0 and __left_down then
    __world:send(player.id, 'cmd_left_released')
    __left_down = false
  elseif o[4] == 1 and not __left_down then
    __world:send(player.id, 'cmd_left_pressed')
    __left_down = true
  end
  if o[5] == 0 and __down_down then
    __world:send(player.id, 'cmd_down_released')
    __down_down = false
  elseif o[5] == 1 and not __down_down then
    __world:send(player.id, 'cmd_down_pressed')
    __down_down = true
  end
  if o[6] == 0 and __up_down then
    __world:send(player.id, 'cmd_up_released')
    __up_down = false
  elseif o[6] == 1 and not __up_down then
    __world:send(player.id, 'cmd_up_pressed')
    __up_down = true
  end
  if o[7] == 0 and __primary_down then
    __world:send(player.id, 'cmd_primary_released')
    __primary_down = false
  elseif o[7] == 1 and not __primary_down then
    __world:send(player.id, 'cmd_primary_pressed')
    __primary_down = true
  end
  if o[8] == 0 and __secondary_down then
    __world:send(player.id, 'cmd_secondary_released')
    __secondary_down = false
  elseif o[8] == 1 and not __secondary_down then
    __world:send(player.id, 'cmd_secondary_pressed')
    __secondary_down = true
  end
  local round
  round = function(x)
    return math.floor(x + 0.5)
  end
  if player.lerp_x then
    if 1 <= math.abs(player.lerp_x - o[9]) then
      print("does not equal: " .. player.lerp_x .. " " .. o[9])
      print("does not equal: " .. round(player.lerp_x) .. " " .. round(o[9]))
      exit()
    end
  end
  return __update(o[1])
end
local __sample_input
__sample_input = function()
  if (love.keyboard.isDown("right") or love.keyboard.isDown("f")) and not __right_down then
    __world:send(player.id, 'cmd_right_pressed')
    __right_down = true
  elseif not (love.keyboard.isDown("right") or love.keyboard.isDown("f")) and __right_down then
    __world:send(player.id, 'cmd_right_released')
    __right_down = false
  end
  if (love.keyboard.isDown("left") or love.keyboard.isDown("e")) and not __left_down then
    __world:send(player.id, 'cmd_left_pressed')
    __left_down = true
  elseif not (love.keyboard.isDown("left") or love.keyboard.isDown("e")) and __left_down then
    __world:send(player.id, 'cmd_left_released')
    __left_down = false
  end
  if (love.keyboard.isDown("down") or love.keyboard.isDown("d")) and not __down_down then
    __world:send(player.id, 'cmd_down_pressed')
    __down_down = true
  elseif not (love.keyboard.isDown("down") or love.keyboard.isDown("d")) and __down_down then
    __world:send(player.id, 'cmd_down_released')
    __down_down = false
  end
  if (love.keyboard.isDown("up") or love.keyboard.isDown("c")) and not __up_down then
    __world:send(player.id, 'cmd_up_pressed')
    __up_down = true
  elseif not (love.keyboard.isDown("up") or love.keyboard.isDown("c")) and __up_down then
    __world:send(player.id, 'cmd_up_released')
    __up_down = false
  end
  if (love.keyboard.isDown("z") or love.keyboard.isDown("j")) and not __primary_down then
    __world:send(player.id, 'cmd_primary_pressed')
    __primary_down = true
  elseif not (love.keyboard.isDown("z") or love.keyboard.isDown("j")) and __primary_down then
    __world:send(player.id, 'cmd_primary_released')
    __primary_down = false
  end
  if (love.keyboard.isDown("x") or love.keyboard.isDown("g")) and not __secondary_down then
    __world:send(player.id, 'cmd_secondary_pressed')
    __secondary_down = true
  elseif not (love.keyboard.isDown("x") or love.keyboard.isDown("g")) and __secondary_down then
    __world:send(player.id, 'cmd_secondary_released')
    __secondary_down = false
  end
end
local __replay_record_frame
__replay_record_frame = function(dt)
  local s = dt
  s = s .. ' ' .. __tick
  s = s .. ' ' .. ((function()
    if __right_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. ((function()
    if __left_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. ((function()
    if __down_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. ((function()
    if __up_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. ((function()
    if __primary_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. ((function()
    if __secondary_down then
      return 1
    else
      return 0
    end
  end)())
  s = s .. ' ' .. player.lerp_x
  s = s .. ' ' .. player.lerp_y
  s = s .. '\n'
  return love.filesystem.append('replay.log', s)
end
love.update = function(dt)
  __tick = love.timer.getTime() - __last_time
  __sample_input()
  return __update(dt)
end
love.load = function()
  __last_time = love.timer.getTime()
  __random_gen = love.math.newRandomGenerator(os.time())
  local major, minor, revision, codename = love.getVersion()
  if minor < 10 then
    local message = 'Sorry, you at least need love 0.10.0 to run this. You have version ' .. major .. '.' .. minor .. '.' .. revision
    love.window.showMessageBox('Error', message, 'info', true)
    exit()
  end
  actor.init()
  game_over_font = love.graphics.newFont("assets/font/joystix.ttf", game_over_font_h)
  local font = game_over_font
  love.graphics.setDefaultFilter("nearest", "nearest")
  love.graphics.setFont(font)
  love.graphics.setBackgroundColor(0, 0, 0)
  local flags
  __screenWidth, __screenHeight, flags = love.window.getMode()
  love.physics.setMeter(32)
  levels = load_levels(__on_level_object_creation, __on_level_init_full)
  current_room = levels[1].rooms["start"]
  player = Player()
  __world:send(player.id, 'set_pos', {
    200,
    300
  })
  __world:send(player.id, 'set_anim', {
    anim_name = 'idle'
  })
  local o = Score()
  __world:send(o.id, 'set_subject', player)
  __message_size = 1.5
  __message = {
    '',
    'Super',
    'Samurai',
    'Guy',
    '',
    'Copyright 2016'
  }
  __message_remove_time = __get_time() + __message_duration + 1
end
